 /*
 * StormStreaming JavaScript Library
 * Copyright © 2021-2024 Web-Anatomy s.c. All rights reserved.
 * contact@stormstreaming.com
 * https://stormstreaming.com
 *
 * Version: 4.1.2
 * Version: 4/18/2024, 1:06:56 PM
 *
 * LEGAL NOTICE:
 * This software is subject to the terms and conditions defined in
 * separate license conditions ('LICENSE.txt')
 *
 */var stormLibrary=function(){"use strict";var i,h,n,l,o,s,e;(w=i=i||{})[w.STREAMER=0]="STREAMER",w[w.PLAYER=1]="PLAYER";class r{constructor(e,t){var i=2<arguments.length&&void 0!==arguments[2]?arguments[2]:443,s=!(3<arguments.length&&void 0!==arguments[3])||arguments[3];this.host=e,this.application=t,this.port=i,this.isSSL=s,this.hasFaild=!1}getHost(){return this.host}getApplication(){return this.application}getPort(){return this.port}getIfSSL(){return this.isSSL}getIfFaild(){return this.hasFaild}setAsFaild(e){this.hasFaild=e}getData(){return{serverURL:this.getHost(),application:this.getHost(),serverPort:this.getPort(),isSSL:this.getIfSSL()}}toString(){return"host: "+this.host+" | application: "+this.application+" | port: "+this.port+" | isSSL: "+this.isSSL}}(w=h=h||{})[w.NONE=0]="NONE",w[w.TOKEN=1]="TOKEN";class a{constructor(e){this.PRINT_ON_STARTUP=!0,this.securityMethod=h.NONE,this.token="",this.parse(e)}parse(e){null!=e?(void 0!==e.type&&null!==e.type&&("token"===e.type?this.securityMethod=h.TOKEN:this.securityMethod=h.NONE),void 0!==e.token&&null!==e.token&&(this.token=e.token)):this.securityMethod=h.NONE}setConfig(e){this.parse=e}getSecurityMethod(){return this.securityMethod}setSecurityMethod(e){this.securityMethod="token"===e?h.TOKEN:h.NONE}getToken(){return this.token}setToken(e){this.token=e}print(t){if(this.PRINT_ON_STARTUP||1<arguments.length&&void 0!==arguments[1]&&arguments[1]){let e="";switch(this.securityMethod){case h.NONE:e="none";break;case h.TOKEN:e="token"}t.info(this,"Security Method: "+e)}}}class t{constructor(e,t){this.type=e,this.streamInfo=t}getType(){return this.type}getStreamInfo(){return this.streamInfo}}(w=n=n||{}).RTMP="RTMP",w.RTSP="RTSP",w.WEBRTC="WebRTC",w.HLS="HLS",w.WEB_SOCKETS="WebSockets",w.MPEG_DASH="MpegDash",w.STORM="Storm";class C extends t{constructor(e,t,i){super(n.STORM,t),this.streamKey=e,this.defaultSource=i}getStreamKey(){return this.streamKey}isDefaultSource(){return this.defaultSource}toString(){return"type: Storm | streamKey: "+this.streamKey+" | streamInfo: "+this.streamInfo.toString()}}class b extends t{constructor(e,t,i){super(n.WEBRTC,t),this.streamKey=e,this.defaultSource=i}getStreamKey(){return this.streamKey}isDefaultSource(){return this.defaultSource}toString(){return"type: WebRTC | streamKey: "+this.streamKey}}class S extends t{constructor(e,t,i,s,o,r){super(n.RTMP,o),this.host=e,this.application=t,this.streamKey=i,this.port=s,this.defaultSource=r}getHost(){return this.host}getPort(){return this.port}getApplicationName(){return this.application}getStreamKey(){return this.streamKey}isDefaultSource(){return this.defaultSource}toString(){return"type: RTMP | url: "+this.host+" | port: "+this.port}}(w=l=l||{})[w.EMBEDDED=0]="EMBEDDED",w[w.GATEWAY=1]="GATEWAY";class y{constructor(e){this.bitrate=0,null!=e&&(this.label="sd",void 0!==e.label&&null!==e.label&&(this.label=e.label),void 0!==e.width&&null!==e.width&&(this.width=e.width),void 0!==e.height&&null!==e.height&&(this.height=e.height),void 0!==e.fps&&null!==e.fps&&(this.fps=e.fps),void 0!==e.bitrate)&&null!==e.bitrate&&(this.bitrate=e.bitrate)}getLabel(){return this.label}getWidth(){return this.width}getHeight(){return this.height}getFPS(){return this.fps}getBitrate(){return this.bitrate}toString(){return"label: "+this.label+" | width: "+this.width+" | height: "+this.height+" | bitrate: "+this.bitrate}}class B{constructor(e,t,i){this.streamName=e,this.applicationName=t,this.host=i}getStreamName(){return this.streamName}getApplicationName(){return this.applicationName}getHost(){return this.host}getType(){return n.WEBRTC}}class U extends t{constructor(e,t,i,s,o,r){super(n.RTSP,o),this.host=e,this.application=t,this.streamKey=i,this.port=s,this.defaultSource=r}getHost(){return this.host}getPort(){return this.port}getApplicationName(){return this.application}getStreamKey(){return this.streamKey}isDefaultSource(){return this.defaultSource}toString(){return"type: RTMP | url: "+this.host+" | port: "+this.port}}class W{constructor(e,t,i){this.PRINT_ON_STARTUP=!0,this.DEFAULT_STORM_PORT=443,this.IS_SSL_BY_DEFAULT=!0,this.serverList=new Array,this.sourceList=new Array,this.roleType=t,this.configurationType=i,this.parse(e,t)}parse(e,t){if(this.streamConfig=e,void 0===this.streamConfig||null===this.streamConfig)throw new Error("Stream configuration is missing. Please check stream config!");if(this.configurationType==l.EMBEDDED){if(t==i.PLAYER){if(void 0===this.streamConfig.serverList||null===this.streamConfig.serverList)throw new Error("Server list configuration is missing. Please check stream config!");if(0===this.streamConfig.serverList.length)throw new Error("Server list configuration is empty. Please check stream config!");for(let o=0;o<this.streamConfig.serverList.length;o++){let e,t,i=this.DEFAULT_STORM_PORT,s=this.IS_SSL_BY_DEFAULT;if(void 0===this.streamConfig.serverList[o].host||null===this.streamConfig.serverList[o].host)throw new Error('Error while parsing server object ("host" filed is missing). Please check player config!');if(e=this.streamConfig.serverList[o].host,void 0===this.streamConfig.serverList[o].application||null===this.streamConfig.serverList[o].application)throw new Error('Error while parsing server object ("application" filed is missing). Please check player config!');t=this.streamConfig.serverList[o].application,void 0!==this.streamConfig.serverList[o].port&&null!==this.streamConfig.serverList[o].port&&(i=this.streamConfig.serverList[o].port),void 0!==this.streamConfig.serverList[o].ssl&&null!==this.streamConfig.serverList[o].ssl&&(s=this.streamConfig.serverList[o].ssl),this.serverList.push(new r(e,t,i,s))}if(void 0===this.streamConfig.sourceList||null===this.streamConfig.sourceList)throw new Error("Source list configuration is missing. Please check player config!");if(0===this.streamConfig.sourceList.length)throw new Error("Source list configuration is missing. Please check player config!");for(let p=0;p<this.streamConfig.sourceList.length;p++){let f="none",m=!1;if(void 0===this.streamConfig.sourceList[p].protocol||null===this.streamConfig.sourceList[p].protocol)throw new Error('Error while parsing source object ("protocol" filed is missing). Please check player config!');switch(f=this.streamConfig.sourceList[p].protocol,void 0!==this.streamConfig.sourceList[p].default&&null!==this.streamConfig.sourceList[p].default&&(m=this.streamConfig.sourceList[p].default),f.toLowerCase()){case"storm":let e="",t=null;if(void 0===this.streamConfig.sourceList[p].streamKey||null===this.streamConfig.sourceList[p].streamKey)throw new Error('Missing "streamKey" parameter in stream source element');e=this.streamConfig.sourceList[p].streamKey,t=void 0!==this.streamConfig.sourceList[p].streamInfo&&null!==this.streamConfig.sourceList[p].streamInfo?this.streamConfig.sourceList[p].streamInfo:{label:"",width:0,height:0,fps:0,bitrate:0},this.sourceList.push(new C(e,new y(t),m));break;case"rtmp":let i="",s="",o="",r=1935,n=null;if(void 0===this.streamConfig.sourceList[p].host||null===this.streamConfig.sourceList[p].host)throw new Error('Missing "host" parameter in stream source element');if(i=this.streamConfig.sourceList[p].host,void 0===this.streamConfig.sourceList[p].application||null===this.streamConfig.sourceList[p].application)throw new Error('Missing "application" parameter in stream source element');if(s=this.streamConfig.sourceList[p].application,void 0===this.streamConfig.sourceList[p].streamKey||null===this.streamConfig.sourceList[p].streamKey)throw new Error('Missing "streamName" parameter in stream source element');o=this.streamConfig.sourceList[p].streamKey,void 0!==this.streamConfig.sourceList[p].port&&null!==this.streamConfig.sourceList[p].port&&(r=this.streamConfig.sourceList[p].port),n=void 0!==this.streamConfig.sourceList[p].streamInfo&&null!==this.streamConfig.sourceList[p].streamInfo?this.streamConfig.sourceList[p].streamInfo:{label:"",width:0,height:0,fps:0,bitrate:0},this.sourceList.push(new S(i,s,o,r,new y(n),m));break;case"rtsp":let a="",h="",l="",c=1935,g=null;if(void 0===this.streamConfig.sourceList[p].host||null===this.streamConfig.sourceList[p].host)throw new Error('Missing "host" parameter in stream source element');if(a=this.streamConfig.sourceList[p].host,void 0===this.streamConfig.sourceList[p].application||null===this.streamConfig.sourceList[p].application)throw new Error('Missing "application" parameter in stream source element');if(h=this.streamConfig.sourceList[p].application,void 0===this.streamConfig.sourceList[p].streamKey||null===this.streamConfig.sourceList[p].streamKey)throw new Error('Missing "streamName" parameter in stream source element');l=this.streamConfig.sourceList[p].streamKey,void 0!==this.streamConfig.sourceList[p].port&&null!==this.streamConfig.sourceList[p].port&&(c=this.streamConfig.sourceList[p].port),g=void 0!==this.streamConfig.sourceList[p].streamInfo&&null!==this.streamConfig.sourceList[p].streamInfo?this.streamConfig.sourceList[p].streamInfo:{label:"",width:0,height:0,fps:0,bitrate:0},this.sourceList.push(new U(a,h,l,c,new y(g),m));break;case"webrtc":let d="",u=null;if(void 0===this.streamConfig.sourceList[p].streamKey||null===this.streamConfig.serverList[p].streamKey)throw new Error('Missing "streamName" parameter in stream source element');d=this.streamConfig.sourceList[p].streamKey,u=void 0!==this.streamConfig.sourceList[p].streamInfo&&null!==this.streamConfig.serverList[p].streamInfo?this.streamConfig.sourceList[p].streamKey:{label:"",width:0,height:0,fps:0,bitrate:0},this.sourceList.push(new b(d,new y(u),m));break;default:throw new Error("Error while parsing source object (unknown protocol). Please check player config!")}}}if(t==i.STREAMER){if(void 0===this.streamConfig.publishData||null===this.streamConfig.publishData)throw new Error("Stream data configuration is missing. Please check player config!");if(void 0===this.streamConfig.publishData.protocol||null===this.streamConfig.publishData.protocol)throw new Error('Missing "protocol" field in stream data element. Please check player config!');if("webrtc"!==this.streamConfig.publishData.protocol.toLowerCase())throw new Error('Unknown "protocol" field in stream data element. Please check player config!');{let e,t,i;if(void 0===this.streamConfig.publishData.streamName||null===this.streamConfig.publishData.streamName)throw new Error("Stream data configuration is missing. Please check streamer config!");if(e=this.streamConfig.publishData.streamName,void 0===this.streamConfig.publishData.application||null===this.streamConfig.publishData.application)throw new Error("Stream data configuration is missing. Please check streamer config!");if(t=this.streamConfig.publishData.application,void 0===this.streamConfig.publishData.host||null===this.streamConfig.publishData.host)throw new Error("Stream data configuration is missing. Please check streamer config!");i=this.streamConfig.publishData.host,this.publishData=new B(e,t,i)}}}else{if(this.configurationType!=l.GATEWAY)throw new Error("Unknown configurationType was defined in stream config!");if(void 0===this.streamConfig.serverList||null===this.streamConfig.serverList)throw new Error("Gateway server list configuration is missing. Please check player config!");if(0===this.streamConfig.serverList.length)throw new Error("Gateway server list configuration is empty. Please check player config!");for(let o=0;o<this.streamConfig.serverList.length;o++){let e,t,i=this.DEFAULT_STORM_PORT,s=this.IS_SSL_BY_DEFAULT;if(void 0===this.streamConfig.serverList[o].host||null===this.streamConfig.serverList[o].host)throw new Error('Error while parsing server object ("host" filed is missing). Please check player config!');if(e=this.streamConfig.serverList[o].host,void 0===this.streamConfig.serverList[o].application||null===this.streamConfig.serverList[o].application)throw new Error('Error while parsing server object ("application" filed is missing). Please check player config!');t=this.streamConfig.serverList[o].application,void 0!==this.streamConfig.serverList[o].port&&null!==this.streamConfig.serverList[o].port&&(i=this.streamConfig.serverList[o].port),void 0!==this.streamConfig.serverList[o].ssl&&null!==this.streamConfig.serverList[o].ssl&&(s=this.streamConfig.serverList[o].ssl),this.serverList.push(new r(e,t,i,s))}if(void 0===this.streamConfig.streamKey||null===this.streamConfig.streamKey)throw new Error("StreamKey for gateway was not defined! Please check stream config!");this.streamKey=this.streamConfig.streamKey}void 0!==this.streamConfig.security&&null!==this.streamConfig.security?this.securityConfig=new a(this.streamConfig.security):this.securityConfig=new a(null)}getServerList(){return this.serverList}getSourceList(){return this.sourceList}getGatewayStreamKey(){return this.streamKey}getType(e){return e instanceof C?"StormSourceItem":e instanceof S?"RTMPSourceItem":"Object"}addSourceStream(e){let g;switch(this.getType(e)){case"StormSourceItem":case"RTMPSourceItem":g=e;break;case"Object":var d=e;let l="none",c=!1;if(void 0===d.protocol||null===d.protocol)throw new Error('Error while parsing source object ("protocol" filed is missing). Please check player config!');switch(l=d.protocol,void 0!==d.default&&null!==d.default&&(c=d.default),l.toLowerCase()){case"storm":let e="",t=null;if(void 0===d.streamKey||null===d.streamKey)throw new Error('Missing "streamKey" parameter in stream source element');e=d.streamKey,t=void 0!==d.streamInfo&&null!==d.streamInfo?d.streamInfo:{label:"",width:0,height:0,fps:0,bitrate:0},g=new C(e,new y(t),c),this.sourceList.push(g);break;case"rtmp":let i="",s="",o="",r=1935,n=null;if(void 0===d.host||null===d.host)throw new Error('Missing "host" parameter in stream source element');if(i=d.host,void 0===d.application||null===d.application)throw new Error('Missing "application" parameter in stream source element');if(s=d.application,void 0===d.streamKey||null===d.streamKey)throw new Error('Missing "streamName" parameter in stream source element');o=d.streamKey,void 0!==d.port&&null!==d.port&&(r=d.port),n=void 0!==d.streamInfo&&null!==d.streamInfo?d.streamInfo:{label:"",width:0,height:0,fps:0,bitrate:0},g=new S(i,s,o,r,new y(n),c),this.sourceList.push(g);break;case"webrtc":let a="",h=null;if(void 0===d.streamKey||null===d.streamKey)throw new Error('Missing "streamName" parameter in stream source element');a=d.streamKey,h=void 0!==d.streamInfo&&null!==d.streamInfo?d.streamKey:{label:"",width:0,height:0,fps:0,bitrate:0},g=new b(a,new y(h),c),this.sourceList.push(new b(a,new y(h),c));break;default:throw new Error("Error while parsing source object (unknown protocol). Please check player config!")}break;default:throw new Error("Incompatible type")}return g}getSecurityConfig(){return this.securityConfig}getPublishData(){return this.publishData}getConfigurationType(){return this.configurationType}setServerList(e){this.serverList=e}clearSourceList(){this.sourceList=new Array}setSourceList(e){this.sourceList=e}getRole(){return this.roleType}print(t){if(this.PRINT_ON_STARTUP||1<arguments.length&&void 0!==arguments[1]&&arguments[1]){t.info(this,"Server List:");for(let e=0;e<this.serverList.length;e++)t.info(this,"=> ["+e+"] "+this.serverList[e].toString());t.info(this,"Stream List:");for(let e=0;e<this.sourceList.length;e++)t.info(this,"=> ["+e+"] "+this.sourceList[e].toString());this.securityConfig.print(t)}}}class c{constructor(e){this.PRINT_ON_STARTUP=!0,this.minValue=.1,this.maxValue=2,this.startValue=.15,this.targetValue=.1,this.parse(e)}parse(e){this.bufferConfig=e,void 0!==this.bufferConfig&&null!==this.bufferConfig&&(void 0!==this.bufferConfig.minValue&&null!==this.bufferConfig.minValue&&(this.minValue=this.bufferConfig.minValue),void 0!==this.bufferConfig.maxValue&&null!==this.bufferConfig.maxValue&&(this.maxValue=this.bufferConfig.maxValue),void 0!==this.bufferConfig.startValue&&null!==this.bufferConfig.startValue&&(this.startValue=this.bufferConfig.startValue),void 0!==this.bufferConfig.targetValue)&&null!==this.bufferConfig.targetValue&&(this.targetValue=this.bufferConfig.targetValue)}getMinValue(){return this.minValue}getMaxValue(){return this.maxValue}getStartValue(){return this.startValue}getTargetValue(){return this.targetValue}setMinValue(e){this.minValue=e}setMaxValue(e){this.maxValue=e}setTargetValue(e){this.targetValue=e}setStartValue(e){this.startValue=e}setConfig(e){this.bufferConfig=e}print(e){(this.PRINT_ON_STARTUP||1<arguments.length&&void 0!==arguments[1]&&arguments[1])&&e.info(this,"minValue: "+this.minValue+" | maxValue: "+this.maxValue+" | startValue: "+this.startValue+" | targetValue: "+this.targetValue)}}class g{constructor(e){this.PRINT_ON_STARTUP=!0,this.storageEnabled=!0,this.prefix="",this.parse(e)}parse(e){this.storageConfig=e,void 0!==this.storageConfig&&null!==this.storageConfig&&(void 0!==this.storageConfig.enabled&&null!==this.storageConfig.enabled&&(this.storageEnabled=this.storageConfig.enabled),void 0!==this.storageConfig.prefix)&&null!==this.storageConfig.prefix&&(this.prefix=this.storageConfig.prefix)}isStorageEnabled(){return this.storageEnabled}setStorageEnabled(e){this.storageEnabled=e}getPrefix(){return this.prefix}setPrefix(e){this.prefix=e}setConfig(e){this.storageConfig=e}print(e){(this.PRINT_ON_STARTUP||1<arguments.length&&void 0!==arguments[1]&&arguments[1])&&(e.info(this,"StorageConfig:: enabled: "+this.storageEnabled),e.info(this,'StorageConfig:: prefix: "'+this.prefix+'"'))}}(w=o=o||{})[w.FILL=0]="FILL",w[w.LETTER_BOX=1]="LETTER_BOX",w[w.CROP=2]="CROP",w[w.ORIGINAL=3]="ORIGINAL";class d{constructor(e){this.scalingMode=o.LETTER_BOX,this.aspectRatio="none",this.videoWidthValue=100,this.isVideoWidthInPixels=!1,this.wasVideoWidthProvided=!1,this.videoHeightValue=100,this.isVideoHeightInPixels=!1,this.wasVideoHeightProvided=!1,this.parse(e)}parse(e){if(this.videoConfig=e,void 0===this.videoConfig||null===this.videoConfig)throw new Error("Missing video configuration. Please check player config!");if(void 0!==this.videoConfig.aspectRatio&&null!==this.videoConfig.aspectRatio){var e=new RegExp("^[0-9]*\\.?[0-9]+:[0-9]*\\.?[0-9]+$"),t=this.videoConfig.aspectRatio;if(!e.test(t))throw new Error('Parameter "aspectRatio" - must match "number:number" pattern ');this.aspectRatio=t,this.aspectRatio=this.videoConfig.aspectRatio}if(void 0!==this.videoConfig.scalingMode&&null!==this.videoConfig.scalingMode)switch(this.videoConfig.scalingMode.toLowerCase()){case"fill":this.scalingMode=o.FILL;break;case"letterbox":this.scalingMode=o.LETTER_BOX;break;case"crop":this.scalingMode=o.CROP;break;case"original":this.scalingMode=o.ORIGINAL;break;default:throw new Error("Unknown video scaling mode. Please check player config!")}if(void 0!==this.videoConfig.width){if(null===this.videoConfig.width)throw new Error('Parameter "width" cannot be empty');if("number"==typeof this.videoConfig.width)this.videoWidthValue=this.videoConfig.width,this.isVideoWidthInPixels=!0;else{if("string"!=typeof this.videoConfig.width)throw new Error('Unknown type for parameter "width" - it must be a number or a string! ');this.videoConfig.width.toLowerCase().endsWith("px")?(this.videoWidthValue=parseInt(this.videoConfig.width),this.isVideoWidthInPixels=!0):this.videoConfig.width.toLowerCase().endsWith("%")&&(this.videoWidthValue=parseInt(this.videoConfig.width),this.isVideoWidthInPixels=!1)}this.wasVideoWidthProvided=!0}if(void 0!==this.videoConfig.height){if(null===this.videoConfig.height)throw new Error('Parameter "height" cannot be empty');if("number"==typeof this.videoConfig.height)this.videoHeightValue=this.videoConfig.height,this.isVideoHeightInPixels=!0;else{if("string"!=typeof this.videoConfig.height)throw new Error('Unknown type for parameter "height" - it must be a number or a string!');this.videoConfig.height.toLowerCase().endsWith("px")?(this.videoHeightValue=parseInt(this.videoConfig.height),this.isVideoHeightInPixels=!0):this.videoConfig.height.toLowerCase().endsWith("%")&&(this.videoHeightValue=parseInt(this.videoConfig.height),this.isVideoHeightInPixels=!1)}this.wasVideoHeightProvided=!0}if(void 0===this.videoConfig.containerID||null===this.videoConfig.containerID)throw new Error("No video object name was provided for this player. Please check player config!");if(this.containerID=this.videoConfig.containerID,null===document.getElementById(this.containerID))throw new Error('No video object with id "'+this.containerID+'" was found for this player. Please check player config!')}getScalingMode(){return this.scalingMode}setConfig(e){this.videoConfig=e}getContainerID(){return this.containerID}getVideoWidthValue(){return this.videoWidthValue}getIfVideoWidthInPixels(){return this.isVideoWidthInPixels}getIfVideoWidthWasProvided(){return this.wasVideoWidthProvided}getVideoHeightValue(){return this.videoHeightValue}getIfVideoHeightInPixels(){return this.isVideoHeightInPixels}getIfVideoHeightWasProvided(){return this.wasVideoHeightProvided}getAspectRatio(){return this.aspectRatio}setVideoWidthValue(e){this.videoWidthValue=e}setIfVideoWidthInPixels(e){this.isVideoWidthInPixels=e}setVideoHeightValue(e){this.videoHeightValue=e}setIfVideoHeightInPixels(e){this.isVideoHeightInPixels=e}setContainerID(e){this.containerID=e}setScalingMode(e){switch(e.toLowerCase()){case"fill":this.scalingMode=o.FILL;break;case"letterbox":this.scalingMode=o.LETTER_BOX;break;case"crop":this.scalingMode=o.CROP;break;case"original":this.scalingMode=o.ORIGINAL;break;default:throw new Error("Unknown video scaling mode. Please check player config!")}}print(e){let t="";switch(this.scalingMode){case o.FILL:t="fill";break;case o.LETTER_BOX:t="letterbox";break;case o.CROP:t="crop";break;case o.ORIGINAL:t="original"}e.info(this,"VideoConfig :: containerID: "+this.containerID),e.info(this,"VideoConfig :: scalingMode: "+t),e.info(this,"VideoConfig :: width: "+this.videoWidthValue+(this.isVideoWidthInPixels?"px":"%")+(this.wasVideoWidthProvided?" (provided)":" (default)")),e.info(this,"VideoConfig :: height: "+this.videoHeightValue+(this.isVideoHeightInPixels?"px":"%")+(this.wasVideoHeightProvided?" (provided)":" (default)"))}}(w=s=s||{})[w.TRACE=0]="TRACE",w[w.INFO=1]="INFO",w[w.SUCCESS=2]="SUCCESS",w[w.WARNING=3]="WARNING",w[w.ERROR=4]="ERROR";class u{constructor(e){this.PRINT_ON_STARTUP=!0,this.consoleEnabled=!1,this.consoleLogTypes=[s.INFO,s.ERROR,s.SUCCESS,s.TRACE,s.WARNING],this.consoleMonoColor=!1,this.containerEnabled=!1,this.containerLogTypes=[s.INFO,s.ERROR,s.SUCCESS,s.TRACE,s.WARNING],this.containerMonoColor=!1,this.parse(e)}parse(e){if(this.debugConfig=e,void 0!==this.debugConfig&&null!==this.debugConfig){if(void 0!==this.debugConfig.console&&null!=this.debugConfig.console){var t=this.debugConfig.console;if(void 0!==t.enabled&&null!==t.enabled&&(this.consoleEnabled=t.enabled),void 0!==t.logTypes&&null!==t.logTypes&&0!==t.logTypes.length){this.consoleLogTypes=new Array;for(let e=0;e<t.logTypes.length;e++)switch(t.logTypes[e].toLowerCase()){case"info":this.consoleLogTypes.push(s.INFO);break;case"error":this.consoleLogTypes.push(s.ERROR);break;case"warning":this.consoleLogTypes.push(s.WARNING);break;case"success":this.consoleLogTypes.push(s.SUCCESS);break;case"trace":this.consoleLogTypes.push(s.TRACE)}}void 0!==t.monoColor&&null!==t.monoColor&&(this.consoleMonoColor=t.monoColor)}if(void 0!==this.debugConfig.container&&null!=this.debugConfig.container){var i=this.debugConfig.container;if(void 0!==i.enabled&&null!==i.enabled&&(this.containerEnabled=i.enabled),void 0!==i.logTypes&&null!==i.logTypes&&0!==i.logTypes.length){this.containerLogTypes=new Array;for(let e=0;e<i.logTypes.length;e++)switch(i.logTypes[e].toLowerCase()){case"info":this.containerLogTypes.push(s.INFO);break;case"error":this.containerLogTypes.push(s.ERROR);break;case"warning":this.containerLogTypes.push(s.WARNING);break;case"success":this.containerLogTypes.push(s.SUCCESS);break;case"trace":this.containerLogTypes.push(s.TRACE)}}void 0!==i.monoColor&&null!==i.monoColor&&(this.containerMonoColor=i.monoColor),void 0!==i.containerID&&null!==i.containerID&&(this.containerID=i.containerID)}}}isConsoleEnabled(){return this.consoleEnabled}setConsoleEnabled(e){this.consoleEnabled=e}getConsoleLogTypes(){return this.consoleLogTypes}setConsoleLogTypes(t){this.consoleLogTypes=new Array;for(let e=0;e<t.length;e++)switch(t[e].toLowerCase()){case"info":this.consoleLogTypes.push(s.INFO);break;case"error":this.consoleLogTypes.push(s.ERROR);break;case"warning":this.consoleLogTypes.push(s.WARNING);break;case"success":this.consoleLogTypes.push(s.SUCCESS);break;case"trace":this.consoleLogTypes.push(s.TRACE)}}isContainerEnabled(){return this.containerEnabled}setContainerEnabled(e){this.consoleEnabled=e}isConsoleMonoColor(){return this.consoleMonoColor}setConsoleMonoColor(e){this.consoleMonoColor=e}getContainerLogTypes(){return this.containerLogTypes}setContainerLogTypes(t){this.containerLogTypes=new Array;for(let e=0;e<t.length;e++)switch(t[e].toLowerCase()){case"info":this.containerLogTypes.push(s.INFO);break;case"error":this.containerLogTypes.push(s.ERROR);break;case"warning":this.containerLogTypes.push(s.WARNING);break;case"success":this.containerLogTypes.push(s.SUCCESS);break;case"trace":this.containerLogTypes.push(s.TRACE)}}getContainerID(){return this.containerID}setContainerID(e){this.containerID=e}isContainerMonoColor(){return this.containerMonoColor}setContainerMonoColor(e){this.containerMonoColor=e}setConfig(e){this.debugConfig=e}print(e){if(this.PRINT_ON_STARTUP||1<arguments.length&&void 0!==arguments[1]&&arguments[1]){let t="";for(let e=0;e<this.consoleLogTypes.length;e++)switch(this.consoleLogTypes[e]){case s.TRACE:t+="TRACE, ";break;case s.SUCCESS:t+="SUCCESS, ";break;case s.WARNING:t+="WARNING, ";break;case s.INFO:t+="INFO, ";break;case s.ERROR:t+="ERROR, "}e.info(this,"Console:: enabled: "+this.consoleEnabled),e.info(this,"Console:: logTypes: "+t),e.info(this,"Console:: monoColor: "+this.consoleMonoColor);let i="";for(let e=0;e<this.containerLogTypes.length;e++)switch(this.containerLogTypes[e]){case s.TRACE:i+="TRACE, ";break;case s.SUCCESS:i+="SUCCESS, ";break;case s.WARNING:i+="WARNING, ";break;case s.INFO:i+="INFO, ";break;case s.ERROR:i+="ERROR, "}e.info(this,"Container:: enabled: "+this.containerEnabled),e.info(this,"Container:: logTypes: "+i),e.info(this,"Container:: containerID: "+this.containerID),e.info(this,"Container:: monoColor: "+this.consoleMonoColor)}}}class f{constructor(e){this.PRINT_ON_STARTUP=!0,this.startVolume=100,this.maxVolume=100,this.rememberValue=!0,this.parse(e)}parse(e){this.volumeConfig=e,void 0!==this.volumeConfig&&null!==this.volumeConfig&&(void 0!==this.volumeConfig.startVolume&&null!==this.volumeConfig.startVolume&&(this.startVolume=this.volumeConfig.startVolume),void 0!==this.volumeConfig.maxVolume&&null!==this.volumeConfig.maxVolume&&(this.maxVolume=this.volumeConfig.maxVolume),void 0!==this.volumeConfig.rememberValue)&&null!==this.volumeConfig.rememberValue&&(this.rememberValue=this.volumeConfig.rememberValue)}getStartVolume(){return this.startVolume}setStartVolume(e){this.startVolume=e}getMaxVolume(){return this.maxVolume}setMaxVolume(e){this.maxVolume=e}isRememberValue(){return this.rememberValue}setRememberValue(e){this.rememberValue=e}setConfig(e){this.volumeConfig=e}print(e){(this.PRINT_ON_STARTUP||1<arguments.length&&void 0!==arguments[1]&&arguments[1])&&e.info(this,"Audio :: startVolume: "+this.startVolume+" | maxVolume: "+this.maxVolume+" | rememberValue: "+this.rememberValue)}}class m{constructor(e){this.PRINT_ON_STARTUP=!0,this.restartOnError=!1,this.reconnectTime=3,this.autoStart=!1,this.autoConnect=!0,this.startOnDOMReady=!1,this.iOSOnDomReadyFix=!0,this.enabledProtocols=new Array(n.STORM,n.RTMP,n.HLS),this.restartOnFocus=!0,this.parse(e)}parse(e){if(this.settingsConfig=e,void 0!==this.settingsConfig.autoConnect&&null!==this.settingsConfig.autoConnect&&(this.autoConnect=this.settingsConfig.autoConnect),void 0!==this.settingsConfig.autoStart&&null!==this.settingsConfig.autoStart&&(this.autoStart=this.settingsConfig.autoStart),void 0!==this.settingsConfig.restartOnFocus&&null!==this.settingsConfig.restartOnFocus&&(this.restartOnFocus=this.settingsConfig.restartOnFocus),void 0!==this.settingsConfig.restartOnError&&null!==this.settingsConfig.restartOnError&&(this.restartOnError=this.settingsConfig.restartOnError),void 0!==this.settingsConfig.reconnectTime&&null!==this.settingsConfig.reconnectTime&&(this.reconnectTime=this.settingsConfig.reconnectTime),void 0!==this.settingsConfig.enabledProtocols&&null!==this.settingsConfig.enabledProtocols){var t=this.settingsConfig.enabledProtocols;if(0===t.length)throw new Error('Missing "enabledProtocols" field. Please check your player config!');this.enabledProtocols=new Array;for(let e=0;e<t.length;e++)switch(t[e].toLowerCase()){case"storm":this.enabledProtocols.push(n.STORM);break;case"hls":this.enabledProtocols.push(n.HLS);break;case"webrtc":this.enabledProtocols.push(n.WEBRTC);break;default:throw new Error('Unknown protocol "'+t[e]+'". Please check your player config!')}}void 0!==this.settingsConfig.buffer&&null!==this.settingsConfig.buffer?this.bufferConfig=new c(this.settingsConfig.buffer):this.bufferConfig=new c(null),void 0!==this.settingsConfig.storage&&null!==this.settingsConfig.storage?this.storageConfig=new g(this.settingsConfig.storage):this.storageConfig=new g(null),void 0!==this.settingsConfig.video&&null!==this.settingsConfig.video?this.videoConfig=new d(this.settingsConfig.video):this.videoConfig=new d(null),void 0!==this.settingsConfig.audio&&null!==this.settingsConfig.audio?this.audioConfig=new f(this.settingsConfig.volume):this.audioConfig=new f(null),void 0!==this.settingsConfig.debug&&null!==this.settingsConfig.debug?this.debugConfig=new u(this.settingsConfig.debug):this.debugConfig=new u(null)}getEnabledProtocols(){return this.enabledProtocols}getIfProtocolEnabled(e){return 0<=this.enabledProtocols.indexOf(e)}getBufferConfig(){return this.bufferConfig}getAudioConfig(){return this.audioConfig}getVideoConfig(){return this.videoConfig}getIfRestartOnError(){return this.restartOnError}getReconnectTime(){return this.reconnectTime}getIfAutoStart(){return this.autoStart}setAutoStart(e){this.autoStart=e}getIfAutoConnect(){return this.autoConnect}getIfRestartOnFocus(){return this.restartOnFocus}getDebugConfig(){return this.debugConfig}getStorageConfig(){return this.storageConfig}setConfig(e){this.settingsConfig=e}getIfStartOnDOMReadyEnabled(){return this.startOnDOMReady}getIfIOSOnDomStartFixEnabled(){return this.iOSOnDomReadyFix}print(e){if(this.PRINT_ON_STARTUP||1<arguments.length&&void 0!==arguments[1]&&arguments[1]){let t="";for(let e=0;e<this.enabledProtocols.length;e++)switch(this.enabledProtocols[e]){case n.WEB_SOCKETS:t+="WebSockets, ";break;case n.HLS:t+="HLS, ";break;case n.WEBRTC:t+="WebRTC, "}e.info(this,"SettingsConfig :: autoStart: "+this.autoStart),e.info(this,"SettingsConfig :: restartOnError: "+this.restartOnError),e.info(this,"SettingsConfig :: reconnectTime: "+this.reconnectTime),e.info(this,"SettingsConfig :: enabledProtocols: "+t),this.bufferConfig.print(e),this.videoConfig.print(e),this.audioConfig.print(e),this.storageConfig.print(e),this.debugConfig.print(e)}}}class p{constructor(e){this.PRINT_ON_STARTUP=!0,this.roleType=i.PLAYER,this.demoMode=!1,this.parse(e)}parse(e){if(this.config=e,void 0!==this.config.role&&null!==this.config.role)switch(this.config.role.toLowerCase()){case"player":this.roleType=i.PLAYER;break;case"streamer":this.roleType=i.STREAMER;break;default:throw new Error('Unknown config role:"'+this.config.role+'"')}if(void 0===this.config.configurationType||null===this.config.configurationType)throw new Error("No connectionType field was provided. Please check your player config!");switch(this.config.configurationType.toLowerCase()){case"embedded":this.configurationType=l.EMBEDDED;break;case"gateway":this.configurationType=l.GATEWAY;break;default:throw new Error('Unknown config type:"'+this.configurationType+'"')}if(void 0===this.config.stream||null===this.config.stream)throw new Error("No stream field was provided. Please check your player config!");this.stream=new W(this.config.stream,this.roleType,this.configurationType),void 0!==this.config.settings&&null!==this.config.settings?this.settings=new m(this.config.settings):this.settings=new m(null),void 0!==this.config.demoMode&&null!==this.config.demoMode&&(this.demoMode=this.config.demoMode)}getConfigurationType(){return this.configurationType}getRole(){return this.roleType}getStream(){return this.stream}getSettings(){return this.settings}setConfig(e){this.config=e}getIfDemoMode(){return this.demoMode}print(e){(this.PRINT_ON_STARTUP||1<arguments.length&&void 0!==arguments[1]&&arguments[1])&&(this.stream.print(e),this.settings.print(e))}}class v{static addLeadingZero(e){return e<10?"0"+e:String(e)}static generateUniqueString(t){let i="";var s="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",o=s.length;for(let e=0;e<t;e++)i+=s.charAt(Math.floor(Math.random()*o));return i}}class E{constructor(e,t){this.colorOrder=["red","green","blue","orange","black","violet"],this.logMemory=[],this.libraryInstanceID=-1,this.playerInstanceID=-1,this.debugConfig=e,this.stormPlayer=t,this.libraryInstanceID=this.stormPlayer.getLibraryID();e=this.colorOrder.length<t.getLibraryID()?this.colorOrder.length-1:t.getLibraryID();this.monoColor=this.colorOrder[e]}info(e,t){e=this.logData(e,t);this.debugConfig.isConsoleEnabled()&&0<=this.debugConfig.getConsoleLogTypes().indexOf(s.INFO)&&(t=this.debugConfig.isConsoleMonoColor()?this.monoColor:E.INFO_COLOR,console.log("%c "+e,"color: "+t)),this.debugConfig.isContainerEnabled()&&0<=this.debugConfig.getContainerLogTypes().indexOf(s.INFO)&&(t=this.debugConfig.isContainerMonoColor()?this.monoColor:E.INFO_COLOR,this.writeToContainer(e,t))}warning(e,t){e=this.logData(e,t);this.debugConfig.isConsoleEnabled()&&0<=this.debugConfig.getConsoleLogTypes().indexOf(s.WARNING)&&(t=this.debugConfig.isConsoleMonoColor()?this.monoColor:E.WARNING_COLOR,console.log("%c "+e,"color: "+t)),this.debugConfig.isContainerEnabled()&&0<=this.debugConfig.getContainerLogTypes().indexOf(s.WARNING)&&(t=this.debugConfig.isContainerMonoColor()?this.monoColor:E.WARNING_COLOR,this.writeToContainer(e,t))}error(e,t){e=this.logData(e,t);this.debugConfig.isConsoleEnabled()&&0<=this.debugConfig.getConsoleLogTypes().indexOf(s.ERROR)&&(t=this.debugConfig.isConsoleMonoColor()?this.monoColor:E.ERROR_COLOR,console.log("%c "+e,"color: "+t)),this.debugConfig.isContainerEnabled()&&0<=this.debugConfig.getContainerLogTypes().indexOf(s.ERROR)&&(t=this.debugConfig.isContainerMonoColor()?this.monoColor:E.ERROR_COLOR,this.writeToContainer(e,t))}success(e,t){e=this.logData(e,t);this.debugConfig.isConsoleEnabled()&&0<=this.debugConfig.getConsoleLogTypes().indexOf(s.SUCCESS)&&(t=this.debugConfig.isConsoleMonoColor()?this.monoColor:E.SUCCESS_COLOR,console.log("%c "+e,"color: "+t)),this.debugConfig.isContainerEnabled()&&0<=this.debugConfig.getContainerLogTypes().indexOf(s.SUCCESS)&&(t=this.debugConfig.isContainerMonoColor()?this.monoColor:E.SUCCESS_COLOR,this.writeToContainer(e,t))}trace(e,t){e=this.logData(e,t);this.debugConfig.isConsoleEnabled()&&0<=this.debugConfig.getConsoleLogTypes().indexOf(s.TRACE)&&(t=this.debugConfig.isConsoleMonoColor()?this.monoColor:E.TRACE_COLOR,console.log("%c "+e,"color: "+t)),this.debugConfig.isContainerEnabled()&&0<=this.debugConfig.getContainerLogTypes().indexOf(s.TRACE)&&(t=this.debugConfig.isContainerMonoColor()?this.monoColor:E.TRACE_COLOR,this.writeToContainer(e,t))}logData(e,t){var i=new Date,s=v.addLeadingZero(i.getHours()),o=v.addLeadingZero(i.getMinutes()),i=v.addLeadingZero(i.getSeconds());let r=String(this.libraryInstanceID);0<=this.playerInstanceID&&(r+="|"+this.playerInstanceID);s="(Storm) [ID:"+r+"] ["+s+":"+o+":"+i+"] :: "+t;return this.logMemory.push(s),s}writeToContainer(e,t){var i=this.debugConfig.getContainerID(),i=document.getElementById(i),s=document.createElement("span");s.innerText=e,s.style.color=t,i.appendChild(s)}setPlayerID(e){this.playerInstanceID=e}getAllLogs(){return this.logMemory}}E.INFO_COLOR="blue",E.WARNING_COLOR="orange",E.ERROR_COLOR="red",E.SUCCESS_COLOR="green",E.TRACE_COLOR="black";class F{constructor(){this.bandwidthCapabilities=0}setBandwidthCapabilities(e){this.bandwidthCapabilities=e}getBandwidthCapabilities(){return this.bandwidthCapabilities}}(w=e=e||{}).NOT_INITIALIZED="notInitialized",w.INITIALIZED="initialized",w.STARTED="started",w.BUFFERING="buffering",w.PLAYING="playing",w.PAUSED="paused",w.STOPPED="stopped",w.DISCONNECTED="disconnected",w.DESTROYED="destroyed";var w="undefined"!=typeof globalThis?globalThis:"undefined"!=typeof window?window:"undefined"!=typeof global?global:"undefined"!=typeof self?self:{};function x(e){return e&&e.__esModule&&Object.prototype.hasOwnProperty.call(e,"default")?e.default:e}function I(){return Y.Date.now()}var k=NaN,H="[object Symbol]",_=/^\s+|\s+$/g,j=/^[-+]0x[0-9a-f]+$/i,z=/^0b[01]+$/i,K=/^0o[0-7]+$/i,G=parseInt,w="object"==typeof w&&w&&w.Object===Object&&w,L="object"==typeof self&&self&&self.Object===Object&&self,Y=w||L||Function("return this")(),Z=Object.prototype.toString,q=Math.max,X=Math.min;function P(e){var t=typeof e;return e&&("object"==t||"function"==t)}function T(e){if("number"==typeof e)return e;if("symbol"==typeof(i=e)||!!(t=i)&&"object"==typeof t&&Z.call(i)==H)return k;var t;if("string"!=typeof(e=P(e)?P(t="function"==typeof e.valueOf?e.valueOf():e)?t+"":t:e))return 0===e?e:+e;e=e.replace(_,"");var i=z.test(e);return i||K.test(e)?G(e.slice(2),i?2:8):j.test(e)?k:+e}var O,R,N,Q=x(function(s,i,e){var o,r,n,a,h,l,c=0,g=!1,d=!1,t=!0;if("function"!=typeof s)throw new TypeError("Expected a function");function u(e){var t=o,i=r;return o=r=void 0,c=e,a=s.apply(i,t)}function f(e){var t=e-l;return void 0===l||i<=t||t<0||d&&n<=e-c}function m(){var e,t=I();if(f(t))return p(t);h=setTimeout(m,(e=i-((t=t)-l),d?X(e,n-(t-c)):e))}function p(e){return h=void 0,t&&o?u(e):(o=r=void 0,a)}function C(){var e=I(),t=f(e);if(o=arguments,r=this,l=e,t){if(void 0===h)return c=e=l,h=setTimeout(m,i),g?u(e):a;if(d)return h=setTimeout(m,i),u(l)}return void 0===h&&(h=setTimeout(m,i)),a}return i=T(i)||0,P(e)&&(g=!!e.leading,d="maxWait"in e,n=d?q(T(e.maxWait)||0,i):n,t="trailing"in e?!!e.trailing:t),C.cancel=function(){void 0!==h&&clearTimeout(h),o=l=r=h=void(c=0)},C.flush=function(){return void 0===h?a:p(I())},C});class J{constructor(e){this.LOG_ACTIVITY=!0,this.videoWidth=0,this.videoHeight=0,this.wasUnmuted=!1,this.isMuted=!1,this.currentVolume=100,this.forceMute=!1,this.isInFullScreenMode=!1,this.hadPlayed=!1,this.main=e,this.containerID=e.getConfigManager().getSettings().getVideoConfig().getContainerID(),this.logger=e.getLogger(),this.initialize()}initialize(){const e=this;if(null==document.getElementById(this.containerID))throw new Error("No parent element for the storm library was defined!");if(this.parentContainer=document.getElementById(this.containerID),this.videoContainer=document.createElement("div"),null==this.parentContainer)throw new Error("No parent element for the storm library was defined!");this.parentContainer.appendChild(this.videoContainer),this.videoElement=document.createElement("video"),this.videoContainer.appendChild(this.videoElement),this.isInFullScreenMode=!1,this.videoContainer.setAttribute("id","stormLibrary_"+this.main.getLibraryID()),this.videoContainer.style.overflow="hidden",this.videoContainer.style.position="relative",this.videoContainer.classList.add("stormLibrary"),this.videoElement.style.objectFit="fill",this.resizeObserver=new ResizeObserver(Q(function(){e.onResize()},100)),this.configureVideoElement(),this.attachEvents(),this.resizeVideo(),this.scaleVideo(),this.resizeObserver.observe(this.parentContainer),this.main.addEventListener("metadataReceived",e=>{this.videoWidth=e.metadata.getVideoWidth(),this.videoHeight=e.metadata.getVideoHeight(),this.scaleVideo()}),document.addEventListener("fullscreenchange",function(){e.onFullScreenChange()},!1),document.addEventListener("webkitfullscreenchange",function(){e.onFullScreenChange()},!1),document.addEventListener("mozfullscreenchange",function(){e.onFullScreenChange()},!1),document.addEventListener("webkitendfullscreen",function(){e.onFullScreenChange()},!1),this.videoElement.addEventListener("webkitendfullscreen",function(){e.onFullScreenChange()},!1)}onFullScreenChange(){null==document.fullscreenElement?(this.isInFullScreenMode=!1,this.logger.info(this,"The library has exited FullScreen mode!"),this.main.dispatchEvent("fullScreenExit",{ref:this.main})):(this.isInFullScreenMode=!0,this.logger.info(this,"The library has entered FullScreen mode!"),this.main.dispatchEvent("fullScreenEnter",{ref:this.main}))}onResize(){var e,t;null!=this.parentContainer&&(this.tempContainerWidth=null==(e=this.parentContainer)?void 0:e.getBoundingClientRect().width,this.tempContainerHeight=null==(e=this.parentContainer)?void 0:e.getBoundingClientRect().height,e=this.main.getConfigManager().getSettings().getVideoConfig().getIfVideoWidthInPixels(),t=this.main.getConfigManager().getSettings().getVideoConfig().getIfVideoHeightInPixels(),e&&t||(this.resizeVideo(),this.scaleVideo()))}configureVideoElement(){var e=this.main.getConfigManager().getSettings().getIfAutoStart(),t=this.main.getConfigManager().getSettings().getAudioConfig().getStartVolume();this.main.getStorageManager().getField("playerVolume")?this.currentVolume=Number(this.main.getStorageManager().getField("playerVolume")):this.currentVolume=t,e&&!this.wasUnmuted&&(this.isMuted=!0,this.forceMute=!0),this.videoElement.setAttribute("playsinline","playsinline"),this.videoElement.setAttribute("webkit-playsinline","webkit-playsinline"),this.videoElement.muted=this.isMuted,this.videoElement.volume=this.currentVolume/100,this.main.dispatchEvent("videoElementCreate",{ref:this.main,videoElement:this.videoElement})}attachEvents(){let s=this;this.videoElement.onload=function(){},e.PLAYING,this.videoElement.onerror=function(e){},this.videoElement.onvolumechange=function(e){s.dispatchVolumeEvent()},this.videoElement.ontimeupdate=function(e){var t=s.videoElement.videoWidth,i=s.videoElement.videoHeight;0==t||0==i||t===s.videoWidth&&i===s.videoHeight||(s.videoWidth=t,s.videoHeight=i,s.scaleVideo())},this.videoElement.onended=function(e){}}resizeVideo(){var e=this.main.getConfigManager().getSettings().getVideoConfig().getIfVideoWidthInPixels(),t=this.main.getConfigManager().getSettings().getVideoConfig().getIfVideoHeightInPixels(),i=this.main.getConfigManager().getSettings().getVideoConfig().getVideoWidthValue(),s=this.main.getConfigManager().getSettings().getVideoConfig().getVideoHeightValue(),o=this.main.getConfigManager().getSettings().getVideoConfig().getAspectRatio();let r=0,n=0;var a=Number(o.split(":")[0]),h=Number(o.split(":")[1]);"none"==o?(e?r=i:null!=this.parentContainer&&(r=this.tempContainerWidth*i/100),t?n=s:null!=this.parentContainer&&(n=this.tempContainerHeight*s/100)):(e?r=i:null!=this.parentContainer&&(r=this.tempContainerWidth*i/100),n=r*h/a),this.containerWidth=r,this.containerHeight=n,null!==this.videoContainer&&(this.videoContainer.style.width=r+"px",this.videoContainer.style.height=n+"px")}scaleVideo(){if(this.scalingMode=this.main.getConfigManager().getSettings().getVideoConfig().getScalingMode(),null!==this.videoElement){let e=0,t=0,i=0,s=0;switch(this.scalingMode){case o.FILL:i=this.containerWidth,s=this.containerHeight;break;case o.CROP:i=this.containerWidth,(s=this.videoHeight*this.containerWidth/this.videoWidth)>=this.containerHeight?(e=0,t=(s-this.containerHeight)/2*-1):(s=this.containerHeight,i=this.videoWidth*this.containerHeight/this.videoHeight,t=0,e=(i-this.containerWidth)/2*-1);break;case o.LETTER_BOX:i=this.containerWidth,(!((s=this.videoHeight*this.containerWidth/this.videoWidth)<=this.containerHeight)||(e=0,t=(s-this.containerHeight)/2*-1,s>this.containerHeight))&&(s=this.containerHeight,i=this.videoWidth*this.containerHeight/this.videoHeight,t=0,e=(i-this.containerWidth)/2*-1);break;case o.ORIGINAL:i=this.videoWidth,s=this.videoHeight,e=(this.videoWidth-this.containerWidth)/-2,t=(this.videoHeight-this.containerHeight)/-2}this.videoElement.style.left=Math.floor(e)+"px",this.videoElement.style.top=Math.floor(t)+"px",this.videoElement.style.width=Math.ceil(i)+"px",this.videoElement.style.height=Math.ceil(s)+"px",this.videoElement.style.position="absolute"}}dispatchVolumeEvent(){var e=this.forceMute?"browser":"user",t={volume:100*this.videoElement.volume,isMuted:this.videoElement.muted,type:e};this.LOG_ACTIVITY&&this.logger.info(this,"VideoContainer :: Event: onVolumeChange: "+JSON.stringify(t)),this.main.dispatchEvent("volumeChange",{ref:this.main,mode:"mse",volume:100*this.videoElement.volume,muted:this.videoElement.muted,invokedBy:e})}play(){let t=this;this.videoElement.play().then(e=>function(){}).catch(function(e){"NotAllowedError"===e.name&&(t.videoElement.muted=!0,t.forceMute=!0,t.videoElement.setAttribute("playsinline","playsinline"),t.videoElement.setAttribute("webkit-playsinline","webkit-playsinline"),t.wasUnmuted=!1,t.isMuted=!0,t.dispatchVolumeEvent(),t.player)&&t.player.restart()})}mute(){this.isMuted=!0,null!==this.videoElement&&(this.videoElement.muted=this.isMuted)}unmute(){var e;this.wasUnmuted=!0,this.isMuted=!1,this.forceMute=!1,null!==this.videoElement&&(e=this.videoElement.paused,this.videoElement.muted=!1,e!=this.videoElement.paused?this.main.dispatchEvent("interactionRequired",{ref:this.main,mode:"mse"}):this.main.dispatchEvent("videoUnmuted",{ref:this.main}))}setVolume(e){this.isMuted=!1,this.wasUnmuted=!0,this.forceMute=!1,this.currentVolume=e,null!==this.videoElement&&(this.videoElement.volume=e/100),this.main.getStorageManager().saveField("playerVolume",String(e))}getVolume(){return null!==this.videoElement?100*this.videoElement.volume:100}getVideoObject(){return this.videoElement}destroy(){this.LOG_ACTIVITY&&this.logger.info(this,"VideoContainer :: src nulling...");try{this.videoElement.remove(),this.videoContainer.remove()}catch(e){}}setScalingMode(e){switch(e.toLowerCase()){case"fill":this.scalingMode=o.FILL;break;case"crop":this.scalingMode=o.CROP;break;case"letterbox":this.scalingMode=o.LETTER_BOX;break;case"original":this.scalingMode=o.ORIGINAL}this.scaleVideo()}getScalingMode(){let e="";switch(this.scalingMode){case o.FILL:e="fill";break;case o.CROP:e="crop";break;case o.LETTER_BOX:e="letterbox";break;case o.ORIGINAL:e="original"}return e}makeScreenshot(){var e=document.createElement("canvas"),t=e.getContext("2d");let i="";return e.width=this.videoWidth,e.height=this.videoHeight,null!==t&&(t.drawImage(this.videoElement,0,0,this.videoWidth,this.videoHeight),i=e.toDataURL("image/png")),i}setSize(e,t){if("number"==typeof e)this.main.getConfigManager().getSettings().getVideoConfig().setVideoWidthValue(e),this.main.getConfigManager().getSettings().getVideoConfig().setIfVideoWidthInPixels(!0);else{if("string"!=typeof e)throw new Error('Unknown value for parameter "width" - it must be a number or a string! ');e.toLowerCase().endsWith("px")?(this.main.getConfigManager().getSettings().getVideoConfig().setVideoWidthValue(parseInt(e)),this.main.getConfigManager().getSettings().getVideoConfig().setIfVideoWidthInPixels(!0)):e.toLowerCase().endsWith("%")&&(this.main.getConfigManager().getSettings().getVideoConfig().setVideoWidthValue(parseInt(e)),this.main.getConfigManager().getSettings().getVideoConfig().setIfVideoWidthInPixels(!1))}if("number"==typeof t)this.main.getConfigManager().getSettings().getVideoConfig().setVideoHeightValue(t),this.main.getConfigManager().getSettings().getVideoConfig().setIfVideoHeightInPixels(!0);else{if("string"!=typeof t)throw new Error('Unknown value for parameter "width" - it must be a number or a string! ');t.toLowerCase().endsWith("px")?(this.main.getConfigManager().getSettings().getVideoConfig().setVideoHeightValue(parseInt(t)),this.main.getConfigManager().getSettings().getVideoConfig().setIfVideoHeightInPixels(!0)):t.toLowerCase().endsWith("%")&&(this.main.getConfigManager().getSettings().getVideoConfig().setVideoHeightValue(parseInt(t)),this.main.getConfigManager().getSettings().getVideoConfig().setIfVideoHeightInPixels(!1))}this.resizeVideo(),this.scaleVideo()}setWidth(e){if("number"==typeof e)this.main.getConfigManager().getSettings().getVideoConfig().setVideoWidthValue(e),this.main.getConfigManager().getSettings().getVideoConfig().setIfVideoWidthInPixels(!0);else{if("string"!=typeof e)throw new Error('Unknown value for parameter "width" - it must be a number or a string! ');e.toLowerCase().endsWith("px")?(this.main.getConfigManager().getSettings().getVideoConfig().setVideoWidthValue(parseInt(e)),this.main.getConfigManager().getSettings().getVideoConfig().setIfVideoWidthInPixels(!0)):e.toLowerCase().endsWith("%")&&(this.main.getConfigManager().getSettings().getVideoConfig().setVideoWidthValue(parseInt(e)),this.main.getConfigManager().getSettings().getVideoConfig().setIfVideoWidthInPixels(!1))}this.resizeVideo(),this.scaleVideo()}setHeight(e){if("number"==typeof e)this.main.getConfigManager().getSettings().getVideoConfig().setVideoHeightValue(e),this.main.getConfigManager().getSettings().getVideoConfig().setIfVideoHeightInPixels(!0);else{if("string"!=typeof e)throw new Error('Unknown value for parameter "width" - it must be a number or a string! ');e.toLowerCase().endsWith("px")?(this.main.getConfigManager().getSettings().getVideoConfig().setVideoHeightValue(parseInt(e)),this.main.getConfigManager().getSettings().getVideoConfig().setIfVideoHeightInPixels(!0)):e.toLowerCase().endsWith("%")&&(this.main.getConfigManager().getSettings().getVideoConfig().setVideoHeightValue(parseInt(e)),this.main.getConfigManager().getSettings().getVideoConfig().setIfVideoHeightInPixels(!1))}this.resizeVideo(),this.scaleVideo()}enterFullScreen(){this.videoElement.webkitEnterFullScreen?this.videoElement.webkitEnterFullScreen():this.videoElement.requestFullscreen()}exitFullScreen(){this.videoElement.webkitExitFullscreen?document.webkitExitFullscreen():document.exitFullscreen()}isFullScreenMode(){return this.isInFullScreenMode}getWidth(){return this.containerWidth}getHeight(){return this.containerHeight}}class $ extends class{setCookie(e,t,i){var s=new Date,i=(s.setTime(s.getTime()+24*i*60*60*1e3),"; expires="+s.toUTCString());try{return document.cookie=e+"="+(t||"")+i+"; path=/",!0}catch(e){this.onCookieError(e)}return!1}getCookie(e){var i=e+"=";try{var s=document.cookie.split(";");for(let t=0;t<s.length;t++){let e=s[t];for(;" "==e.charAt(0);)e=e.substring(1,e.length);if(0==e.indexOf(i))return e.substring(i.length,e.length)}return null}catch(e){this.onCookieError(e)}}deleteCookie(e){try{return document.cookie=e+"=; Path=/; Expires=Thu, 01 Jan 1970 00:00:01 GMT;",!0}catch(e){this.onCookieError(e)}return!1}onCookieError(e){}}{constructor(e){super(),this.LOG_ACTIVITY=!1,this.DAYS_TILL_EXPIRE=30,this.prefix="",this.isEnabled=!0,this.logger=e.getLogger(),this.prefix=e.getConfigManager().getSettings().getStorageConfig().getPrefix(),this.isEnabled=e.getConfigManager().getSettings().getStorageConfig().isStorageEnabled(),this.LOG_ACTIVITY&&this.logger.info(this,"Creating new StorageManager")}saveField(e,t){1==this.isEnabled&&(this.LOG_ACTIVITY&&this.logger.info(this,"Saving data: "+e+" | "+t),this.setCookie(this.prefix+e,t,this.DAYS_TILL_EXPIRE))}getField(e){var t;return 1==this.isEnabled?(t=this.getCookie(this.prefix+e),this.LOG_ACTIVITY&&this.logger.info(this,"Grabbing data: "+e+" | "+t),t):null}deleteField(e){1==this.isEnabled&&(this.LOG_ACTIVITY&&this.logger.info(this,"Deleting field: "+e),this.deleteCookie(this.prefix+e))}onCookieError(e){this.LOG_ACTIVITY&&this.logger.error(this,"Error on cookie: "+e)}}class M{static hasWebSocketsSupport(){return null!=window.WebSocket}static isMobile(){return new RegExp("Mobile|mini|Fennec|Android|iP(ad|od|hone)").test(navigator.userAgent)}static isCookieEnabled(){let e=!!navigator.cookieEnabled;return"undefined"!=typeof navigator.cookieEnabled||e||(document.cookie="testcookie",e=-1!=document.cookie.indexOf("testcookie")),e}static getOSVersion(){let e="Unknown version",t=M.getOS();if(null!=t){var i;switch(new RegExp("Windows").test(t)&&(i=new RegExp("Windows (.*)"),e=null!=i.exec(t)[1]?i.exec(t)[1]:e,t="Windows"),t){case"Mac OS":case"Mac OS X":case"Android":var s=new RegExp("(?:Android|Mac OS|Mac OS X|MacPPC|MacIntel|Mac_PowerPC|Macintosh) ([\\.\\_\\d]+)");e=s.exec(navigator.userAgent)[1];break;case"iOS":s=new RegExp("OS (\\d+)_(\\d+)_?(\\d+)?");e=(e=s.exec(navigator.userAgent))[1]+"."+e[2]+"."+(0|e[3])}}return e}static getBrowserName(){return M.getFullBrowser().name}static getBrowserVersion(){return M.getFullBrowser().version}static getFullBrowser(){var e=navigator.userAgent;let t=navigator.appName,i=""+parseFloat(navigator.appVersion),s=parseInt(navigator.appVersion,10),o,r,n;return-1!=(r=e.indexOf("Opera"))?(t="Opera",i=e.substring(r+6),-1!=(r=e.indexOf("Version"))&&(i=e.substring(r+8))):-1!=(r=e.indexOf("MSIE"))?(t="Microsoft Internet Explorer",i=e.substring(r+5)):"Netscape"==t&&-1!=e.indexOf("Trident/")?(t="Microsoft Internet Explorer",i=e.substring(r+5),-1!=(r=e.indexOf("rv:"))&&(i=e.substring(r+3))):-1!=(r=e.indexOf("Chrome"))?(t="Chrome",(-1<e.indexOf("FBAV")||-1<e.indexOf("FBAN"))&&(t="Facebook"),-1<e.indexOf("OPR")&&(t="Opera"),-1<e.indexOf("SamsungBrowser")&&(t="Samsung"),i=e.substring(r+7)):-1!=(r=e.indexOf("Safari"))?(t="Safari",i=e.substring(r+7),-1!=(r=e.indexOf("Version"))&&(i=e.substring(r+8)),-1!=e.indexOf("CriOS")&&(t="Chrome"),-1!=e.indexOf("FxiOS")&&(t="Firefox")):-1!=(r=e.indexOf("Firefox"))?(t="Firefox",i=e.substring(r+8)):(o=e.lastIndexOf(" ")+1)<(r=e.lastIndexOf("/"))&&(t=e.substring(o,r),i=e.substring(r+1),t.toLowerCase()==t.toUpperCase())&&(t=navigator.appName),-1!=(n=(i=-1!=(n=(i=-1!=(n=i.indexOf(";"))?i.substring(0,n):i).indexOf(" "))?i.substring(0,n):i).indexOf(")"))&&(i=i.substring(0,n)),s=parseInt(""+i,10),isNaN(s)&&(i=""+parseFloat(navigator.appVersion),s=parseInt(navigator.appVersion,10)),{name:t,fullVersion:i,version:s}}static getOS(){let e="Unknown OS";var t,i=[{os:"Windows 10",code:"(Windows 10.0|Windows NT 10.0)"},{os:"Windows 8.1",code:"(Windows 8.1|Windows NT 6.3)"},{os:"Windows 8",code:"(Windows 8|Windows NT 6.2)"},{os:"Windows 7",code:"(Windows 7|Windows NT 6.1)"},{os:"Windows Vista",code:"Windows NT 6.0"},{os:"Windows Server 2003",code:"Windows NT 5.2"},{os:"Windows XP",code:"(Windows NT 5.1|Windows XP)"},{os:"Windows 2000",code:"(Windows NT 5.0|Windows 2000)"},{os:"Windows ME",code:"(Win 9x 4.90|Windows ME)"},{os:"Windows 98",code:"(Windows 98|Win98)"},{os:"Windows 95",code:"(Windows 95|Win95|Windows_95)"},{os:"Windows NT 4.0",code:"(Windows NT 4.0|WinNT4.0|WinNT|Windows NT)"},{os:"Windows CE",code:"Windows CE"},{os:"Windows 3.11",code:"Win16"},{os:"Android",code:"Android"},{os:"Open BSD",code:"OpenBSD"},{os:"Sun OS",code:"SunOS"},{os:"Chrome OS",code:"CrOS"},{os:"Linux",code:"(Linux|X11(?!.*CrOS))"},{os:"iOS",code:"(iPhone|iPad|iPod)"},{os:"Mac OS X",code:"Mac OS X"},{os:"Mac OS",code:"(Mac OS|MacPPC|MacIntel|Mac_PowerPC|Macintosh)"},{os:"QNX",code:"QNX"},{os:"UNIX",code:"UNIX"},{os:"BeOS",code:"BeOS"},{os:"OS/2",code:"OS\\/2"},{os:"Search Bot",code:"(nuhk|Googlebot|Yammybot|Openbot|Slurp|MSNBot|Ask Jeeves\\/Teoma|ia_archiver)"}];for(t in i){var s=i[t];if(new RegExp(s.code).test(navigator.userAgent)){e=s.os;break}}return e}static hasWebRTCSupport(){let t=!1;try{navigator.getUserMedia||navigator.webkitGetUserMedia||navigator.mozGetUserMedia||navigator.msGetUserMedia||window.RTCPeerConnection;t=!0}catch(e){t=!1}return t}static hasHLSSupport(e){return null!==e&&Boolean(e.canPlayType("application/vnd.apple.mpegURL")||e.canPlayType("audio/mpegurl"))}static hasMSESupport(){var e=window.MediaSource=window.MediaSource||window.WebKitMediaSource;return window.SourceBuffer=window.SourceBuffer||window.WebKitSourceBuffer,e&&"function"==typeof e.isTypeSupported}static hasMMSSupport(){return window.ManagedMediaSource}static isSSL(){return"https:"===location.protocol}}(w=O=O||{})[w.NOT_INITIALIZED=0]="NOT_INITIALIZED",w[w.STARTED=1]="STARTED",w[w.CONNECTING=2]="CONNECTING",w[w.CONNECTED=3]="CONNECTED",w[w.CLOSED=4]="CLOSED",w[w.FAILED=5]="FAILED";class ee{constructor(e,t,i,s,o){this.name=e,this.groupName=t,this.protocolVer=i,this.serverInitTime=s,this.version=o}getName(){return this.name}getGroup(){return this.groupName}getProtocolVersion(){return this.protocolVer}getServerInitTime(){return this.serverInitTime}getVersion(){return this.version}}class te{constructor(e,t,i){this.name=e,this.type=i,this.dvrEnabled=t}getName(){return this.name}getType(){return this.type}getIfDVREnabled(){return this.dvrEnabled}}class ie{constructor(){this.videoWidth=0,this.videoHeight=0,this.videoTimeScale=0,this.constantFrameRate=!1,this.videoDataRate=0,this.frameRate=0,this.encoder="Unknown",this.audioCodec="Unknown",this.videoCodec="Unknown",this.audioChannels=0,this.audioSampleRate=0,this.audioSampleSize=0,this.audioDataRate=0}MetaDataItem(){}setVideoWidth(e){this.videoWidth=e}setVideoHeight(e){this.videoHeight=e}setIfConstantFrameRate(e){this.constantFrameRate=e}setEncoder(e){this.encoder=e}setAudioCodec(e){this.audioCodec=e}setVideoDataRate(e){this.videoDataRate=e}setAudioCodecID(e){this.audioCodec=10===e?"ACC":"Unknown"}setVideoCodec(e){this.videoCodec=e}setVideoCodecID(e){this.videoCodec=7===e?"H.264":"Unknown"}setAudioChannels(e){this.audioChannels=e}setAudioSampleRate(e){this.audioSampleRate=e}setAudioSampleSize(e){this.audioSampleSize=e}setAudioDataRate(e){this.audioDataRate=e}setVideoTimeScale(e){this.videoTimeScale=e}setFrameRate(e){this.frameRate=e}getVideoWidth(){return this.videoWidth}getVideoHeight(){return this.videoHeight}isVariableFPS(){return this.constantFrameRate}getNominalFPS(){return this.frameRate}getEncoder(){return this.encoder}getAudioCodec(){return this.audioCodec}getVideoCodec(){return this.videoCodec}getAudioChannels(){return this.audioChannels}getAudioSampleRate(){return this.audioSampleRate}getAudioSampleSize(){return this.audioSampleSize}getAudioDataRate(){return this.audioDataRate}getVideoTimeScale(){return this.videoTimeScale}toString(){var e="";return(e+="videoWidth: "+this.videoWidth)+(" | videoHeight: "+this.videoHeight)+(" | videoTimeScale: "+this.videoTimeScale)+(" | variableFPS: "+this.constantFrameRate)+(" | nominalFPS: "+this.frameRate)+(" | encoder: "+this.encoder)+(" | audioCodec: "+this.audioCodec)+(" | videoCodec: "+this.videoCodec)+(" | audioChannels: "+this.audioChannels)+(" | audioSampleRate: "+this.audioSampleRate)+(" | audioSampleSize: "+this.audioSampleSize)+(" | audioDataRate: "+this.audioDataRate)}}(L=R=R||{}).MSE="mse",L.HLS="hls",L.WEB_RTC="webrtc",L.ABSTRACT="abstract",L.UNKNOWN="unknown",(w=N=N||{}).NOT_INITIALIZED="NOT_INITIALIZED",w.INITIALIZED="INITIALIZED",w.PLAYING="PLAYING",w.BUFFERING="BUFFERING",w.PAUSED="PAUSED",w.STOPPED="STOPPED",w.NOT_FOUND="NOT_FOUND",w.AWAITING="AWAITING",w.NOT_PUBLISHED="NOT_PUBLISHED",w.UNKNOWN="UNKNOWN",w.UNPUBLISHED="UNPUBLISHED",w.PUBLISHED="PUBLISHED",w.CLOSED="CLOSED";class V extends class{constructor(){this.CONNECTION_TIMEOUT=5,this.isBinary=!0,this.connectionState=O.NOT_INITIALIZED,this.messageCount=0,this.disconnectedByUser=!1,this.isConnected=!1}startConnection(){this.disconnectedByUser=!1,this.connectionState=O.CONNECTING,this.socket=new WebSocket(this.socketURL),this.isBinary&&(this.socket.binaryType="arraybuffer"),this.socket.onopen=e=>{clearTimeout(this.connectionTimeout),this.connectionState=O.CONNECTED,this.onSocketOpen(e)},this.socket.onmessage=e=>{this.messageCount++,this.onSocketMessage(e)},this.socket.onclose=e=>{clearTimeout(this.connectionTimeout),this.connectionState==O.CONNECTED?(this.connectionState=O.CLOSED,this.onSocketClose(e)):this.connectionState=O.FAILED},this.socket.onerror=e=>{if(clearTimeout(this.connectionTimeout),this.connectionState==O.CONNECTING&&this.onSocketError(e),this.connectionState==O.CONNECTED)try{this.socket.close()}catch(e){}},this.connectionTimeout=setTimeout(()=>{try{this.socket.close()}catch(e){}this.connectionState==O.CONNECTING&&(this.connectionState=O.FAILED,this.onSocketError(new ErrorEvent("connectionTimeout")))},1e3*this.CONNECTION_TIMEOUT)}onSocketOpen(e){}onSocketClose(e){}onSocketMessage(e){}onSocketError(e){}onError(e){}sendData(e){if(this.connectionState==O.CONNECTED&&null!==this.socket){if(null!=e)return void this.socket.send(e);this.onError("no data to send")}this.onError("socket not connected")}getConnectionState(){return this.connectionState}disconnect(){this.isConnected=!1,this.logger.warning(this,"Disconnected by user"),this.disconnectedByUser=!0,null!=this.socket&&(this.socket.onopen=null,this.socket.onmessage=null,this.socket.onclose=null,this.socket.onerror=null,this.socket.close())}destroy(){void 0!==this.socket&&null!==this.socket&&(this.socket.onopen=null,this.socket.onmessage=null,this.socket.onclose=null,this.socket.onerror=null,this.socket.close()),this.connectionState=O.CLOSED}getSocketURL(){return this.socketURL}}{constructor(e){super(),this.isAuthorized=!1,this.coreReadyDispatched=!1,this.wasPlaybackStopped=!1,this.lastState="",this.logger=e.getLogger(),this.main=e,this.type=this.main.getConfigManager().getConfigurationType()}initialize(){this.logger.info(this,"Starting new connection with a storm server"),this.pickServerFromList(this.main.getConfigManager().getStream().getServerList()),null!=this.currServer?(this.socketURL=this.createURL(this.currServer),this.logger.info(this,"Starting WebSocket connection with: "+this.socketURL),this.main.dispatchEvent("serverConnectionInitiate",{ref:this.main,serverURL:this.socketURL}),this.main.getConfigManager().getIfDemoMode()?(this.logger.warning(this,"Player is in demo mode, and will not connect with a server!"),this.main.dispatchEvent("authorizationComplete",{ref:this.main})):this.startConnection()):this.logger.error(this,"Connection with the server could not be initialized!")}onSocketOpen(e){this.logger.success(this,"Connection with the server has been established!"),this.main.dispatchEvent("serverConnect",{ref:this.main,serverURL:this.socketURL}),this.isConnected=!0}onSocketError(e){this.isConnected=!1,this.disconnectedByUser||(this.logger.error(this,"Connection with the server failed"),this.main.dispatchEvent("serverConnectionError",{ref:this.main,serverURL:this.socketURL,restart:this.main.getConfigManager().getSettings().getIfRestartOnError()}),0==this.isConnected&&(this.currServer.setAsFaild(!0),this.initiateReconnect()))}onSocketClose(e){this.isConnected=!1,this.disconnectedByUser?this.logger.warning(this,"Force disconnect from server!"):(this.logger.error(this,"Connection with the server has been closed"),this.main.dispatchEvent("serverDisconnect",{ref:this.main,serverURL:this.socketURL,restart:this.main.getConfigManager().getSettings().getIfRestartOnError()}),this.initiateReconnect())}onSocketMessage(e){if("string"==typeof e.data){var t=JSON.parse(e.data),i=t.packetID;switch(i){case"serverHandshake":var s=t.data;this.serverInfo=new ee(s.name,s.group,s.protocolVer,s.serverTime,s.version),"invalid"==s.license&&(this.logger.info(this,"Storm server license is not valid (probably expired or incorrect serial key was provided)!"),this.main.dispatchEvent("invalidLicense",{ref:this.main})),s.protocolVer!=this.main.getPlayerProtocolVersion()&&(this.logger.error(this,`Incompatible protocol version - player is ${this.main.getPlayerProtocolVersion()}, but server is `+s.protocolVer),this.main.dispatchEvent("incompatibleProtocol",{ref:this.main,clientProtocolVer:this.main.getPlayerProtocolVersion(),serverProtocolVersion:s.protocolVer}));break;case"appData":{s=t.data;this.appData=new te(s.name,s.dvrEnabled,s.type);let e=null;s.tokenRequired?this.main.getConfigManager().getStream().getSecurityConfig().getSecurityMethod()==h.TOKEN?(n=this.main.getConfigManager().getStream().getSecurityConfig().getToken(),e={userAgent:navigator.userAgent,token:n,command:"authorize",uniq:v.generateUniqueString(8)+"_"+Date.now().toString().slice(-5)}):(this.logger.error(this,`Application ${s.name} requires token for authentication! Disconnecting!`),this.main.dispatchEvent("authorizationError",{ref:this.main}),this.disconnect()):e={userAgent:navigator.userAgent,token:"",command:"authorize"},this.sendData(JSON.stringify({packetID:"appAuthPacket",data:e}))}break;case"authResultPacket":"success"==t.data.answer?(this.isAuthorized=!0,this.logger.info(this,"Authorization with the sever is complete!"),this.main.dispatchEvent("authorizationComplete",{ref:this.main}),this.main.getConfigManager().getStream().getConfigurationType()==l.GATEWAY&&this.subscribeToStream()):(this.logger.error(this,"Authorization with the sever failed! Disconnecting!"),this.main.dispatchEvent("authorizationError",{ref:this.main}),this.disconnect()),0==this.coreReadyDispatched&&(this.main.dispatchEvent("playerCoreReady",{ref:this.main}),this.coreReadyDispatched=!0);break;case"subscriptionResultPacket":var o=t.data;if("success"==o.status)null!=o.optParameters&&(this.logger.info(this,"Optional Stream Data: "+o.optParameters),this.main.dispatchEvent("optionalStreamData",{ref:this.main,optData:o.optParameters})),this.main.dispatchEvent("subscriptionComplete",{ref:this.main,sourceList:this.main.getSourceList()}),this.onStreamStatus(o);else switch(o.reason){case"NOT_FOUND":this.logger.error(this,"Stream not found"),this.main.dispatchEvent("streamNotFound",{ref:this.main,streamKey:o.streamKey});break;case"INCORRECT_STREAM_KEY":this.logger.error(this,"Stream not found (incorrect streamKey)"),this.main.dispatchEvent("streamNotFound",{ref:this.main,streamKey:o.streamKey});break;case"NOT_AUTHORIZED":this.logger.error(this,"Not authorized for play");break;default:this.logger.error(this,"Could get data from the server: "+o.reason)}break;case"playResultPacket":var r=t.data;if("success"==r.status)switch(r.streamState){case"PUBLISHED":this.logger.success(this,"Playback initialized!"),this.main.dispatchEvent("playbackInitiate",{ref:this.main,streamKey:r.streamKey});break;case"AWAITING":this.main.getPlaybackController().setPlaybackState(N.STOPPED),this.main.dispatchEvent("streamStateChange",{ref:this.main,streamKey:r.streamKey,state:"AWAITING"}),this.logger.info(this,"Stream is not ready yet (state: AWAITING)");break;case"NOT_PUBLISHED":this.main.getPlaybackController().setPlaybackState(N.STOPPED),this.main.dispatchEvent("streamStateChange",{ref:this.main,streamKey:r.streamKey,state:"NOT_PUBLISHED"}),this.logger.info(this,"Stream has ended (state: NOT_PUBLISHED)");break;case"NOT_PUBLISHED":this.main.getPlaybackController().setPlaybackState(N.STOPPED),this.main.dispatchEvent("streamStateChange",{ref:this.main,streamKey:r.streamKey,state:"UNPUBLISHED"}),this.logger.info(this,"Stream is not ready yet (state: UNPUBLISHED");break;case"INITIALIZED":this.main.getPlaybackController().setPlaybackState(N.STOPPED),this.main.dispatchEvent("streamStateChange",{ref:this.main,streamKey:r.streamKey,state:"UNPUBLISHED"}),this.logger.info(this,"Stream is not ready yet (state: INITIALIZED/UNPUBLISHED")}else switch(r.reason){case"NOT_FOUND":this.logger.info(this,"Stream not found"),this.main.dispatchEvent("streamNotFound",{ref:this.main,streamKey:r.streamKey});break;case"INCORRECT_STREAMKEY":this.logger.info(this,"Stream not found (incorrect streamKey)"),this.main.dispatchEvent("streamNotFound",{ref:this.main,streamKey:r.streamKey});break;case"NOT_AUTHORIZED":this.logger.info(this,"Not authorized for play")}break;case"playbackMetadata":var n=t.data,s=new ie;s.setVideoCodecID(n.videoCodecID),s.setVideoWidth(n.videoWidth),s.setVideoHeight(n.videoHeight),s.setVideoDataRate(n.videoDataRate),n.constFrameRate?(s.setIfConstantFrameRate(!0),s.setFrameRate(n.frameRate)):s.setIfConstantFrameRate(!1),s.setAudioCodecID(n.audioCodecID),s.setAudioDataRate(n.audioDataRate),s.setAudioSampleSize(n.audioSampleSize),s.setAudioSampleRate(n.audioSampleRate),s.setAudioChannels(n.audioChannels),this.logger.success(this,"MetaData has arrived!"),this.main.dispatchEvent("metadataReceived",{ref:this.main,metadata:s}),this.player.onMetaData(s);break;case"playbackStopPacket":t.data.newState,this.logger.success(this,"Stream Stop"),this.main.dispatchEvent("streamStop",{ref:this.main,streamKey:this.source.getStreamKey()}),null!=(n=this.player)&&n.stop();break;case"playbackLinkingPacket":s=t.data,n=null!=(n=this.currServer)&&n.getIfSSL()?"https://":"http://",n=(n+=(null==(a=this.currServer)?void 0:a.getHost())+":"+(null==(a=this.currServer)?void 0:a.getPort())+"/")+s.path;null!=(a=this.player)&&a.setURL(n);break;case"playbackProgress":s=t.data;this.main.dispatchEvent("playbackProgress",{ref:this.main,streamKey:this.source.getStreamKey(),streamStartTime:s.streamStartTime,streamDuration:s.streamDuration,playbackStartTime:s.playbackStartTime,playbackDuration:s.playbackDuration,dvrCacheSize:s.dvrCacheSize});break;case"subscriptionUpdatePacket":var a=t.data;this.onStreamStatus(a);break;default:this.logger.error(this,"Unknown packet: "+i)}}else this.player.getPlayerType()==R.MSE&&this.player.pushData(e.data)}onStreamStatus(t){var e,i=new Array;if(null!=t.streamList){for(let e=0;e<t.streamList.length;e++){var s=new y(t.streamList[e].streamInfo),s=new C(t.streamList[e].streamKey,s,!1);i.push(s)}this.main.getConfigManager().getStream().setSourceList(i),this.main.dispatchEvent("sourceListUpdate",{ref:this.main,sourceList:i})}var o=null!=(e=null!=(e=t.streamKey)?e:null==(e=this.source)?void 0:e.getStreamKey())?e:"none";if(this.lastState!=t.streamState)switch(this.lastState=t.streamState,t.streamState){case"AWAITING":this.logger.success(this,"Stream is awaiting start (AWAITING)"),this.main.dispatchEvent("streamStateChange",{ref:this.main,streamKey:o,state:"AWAITING"});break;case"NOT_PUBLISHED":this.logger.success(this,"Stream is awaiting start (NOT_PUBLISHED)"),this.main.dispatchEvent("streamStateChange",{ref:this.main,streamKey:o,state:"NOT_PUBLISHED"});break;case"UNPUBLISHED":this.logger.success(this,"Stream has been unpublished (UNPUBLISHED)"),this.main.dispatchEvent("streamStateChange",{ref:this.main,streamKey:o,state:"UNPUBLISHED"});break;case"PUBLISHED":this.logger.success(this,"Stream is published (PUBLISHED)"),this.main.dispatchEvent("streamStateChange",{ref:this.main,streamKey:o,state:"PUBLISHED"});break;default:this.logger.success(this,"Incorrect state: "+t.streamState)}}sendPauseRequest(){this.wasPlaybackStopped=!0,this.sendData(JSON.stringify({packetID:"pauseRequestPacket"}))}sendPlayRequest(){this.wasPlaybackStopped=!1;let e=null;switch(this.source.getType()){case n.STORM:var t=this.source;e={protocol:"storm",streamKey:t.getStreamKey(),packetizer:null==(t=this.player)?void 0:t.getPlayerType(),startTime:0};break;case n.RTMP:var t=this.source;e={protocol:"rtmp",streamKey:t.getStreamKey(),extHost:t.getHost(),extApplication:t.getApplicationName(),extPort:t.getPort(),packetizer:null==(t=this.player)?void 0:t.getPlayerType(),startTime:0};break;case n.RTSP:t=this.source;e={protocol:"rtsp",streamKey:t.getStreamKey(),extHost:t.getHost(),extApplication:t.getApplicationName(),extPort:t.getPort(),packetizer:null==(t=this.player)?void 0:t.getPlayerType(),startTime:0}}this.sendData(JSON.stringify({packetID:"playRequestPacket",data:e}))}createURL(e){var t="";return(t+=e.getIfSSL()?"wss://":"ws://")+e.getHost()+(":"+e.getPort())+("/"+V.STORM_WEBSOCKET_HARNESS)+("/"+e.getApplication())}initiateReconnect(){var e=this.main.getConfigManager().getSettings().getIfRestartOnError();const t=this.main.getConfigManager().getSettings().getReconnectTime();this.disconnectedByUser||e&&(null!=this.reconnectTimer&&clearTimeout(this.reconnectTimer),this.reconnectTimer=setTimeout(()=>{this.pickServerFromList(this.main.getConfigManager().getStream().getServerList()),null!=this.currServer&&(this.logger.info(this,`Will reconnect to the server in ${t} seconds...`),this.socketURL=this.createURL(this.currServer),this.logger.info(this,"Starting WebSocket connection with: "+this.socketURL),this.main.dispatchEvent("serverConnectionInitiate",{ref:this.main,serverURL:this.socketURL}),this.startConnection())},1e3*t))}subscribeToStream(){var e;this.isConnected&&this.isAuthorized&&(e=null,e={streamKey:this.main.getConfigManager().getStream().getGatewayStreamKey()},this.sendData(JSON.stringify({packetID:"subscriptionRequestPacket",data:e})))}reportLatency(e){var t;0!=e&&(e=Number(e.toFixed(4)),this.isConnected)&&this.isAuthorized&&(t=null,t={streamKey:this.main.getConfigManager().getStream().getGatewayStreamKey(),latency:e},this.sendData(JSON.stringify({packetID:"latencyReportPacket",data:t})))}pickServerFromList(t){let i=null;for(let e=0;e<t.length;e++)if(!t[e].getIfFaild()){i=t[e];break}null==i?(this.logger.error(this,"All connections failed!"),this.main.dispatchEvent("allConnectionsFailed",{ref:this.main,mode:"none"}),0==this.coreReadyDispatched&&(this.main.dispatchEvent("playerCoreReady",{ref:this.main}),this.coreReadyDispatched=!0),this.currServer=null):this.currServer=i}attachPlayer(e){null!=this.player&&this.player.destroy(),this.player=e}requestPlayback(e){if(!this.isConnected)throw new Error("StormLibrary has not established a connection with a server");this.isAuthorized?(this.source=e,this.sendPlayRequest()):this.logger.error(this,'Error on "playSource" - the connection was not authorized!')}newSubscription(e){if(!this.isConnected)throw new Error("StormLibrary has not established a connection with a server");this.isAuthorized?this.sendData(JSON.stringify({packetID:"subscriptionRequestPacket",data:{streamKey:e}})):this.logger.error(this,'Error on "playSource" - the connection was not authorized!')}reinitialize(){this.isConnectionActive()||(this.main.dispatchEvent("serverConnectionInitiate",{ref:this.main,serverURL:this.socketURL}),this.startConnection())}getIfAuthorized(){return this.isAuthorized}getSourceItem(){return this.source}isConnectionActive(){return this.isConnected}destroy(){super.destroy(),null!=this.reconnectTimer&&clearTimeout(this.reconnectTimer)}}V.STORM_WEBSOCKET_HARNESS="storm/v2";class A{constructor(){this.stoppedByBrowser=!1}getPlayerType(){return this.playerType}getMetaData(){return this.metaData}onMetaData(e){this.metaData=e}getIfStoppedByBrowser(){return this.stoppedByBrowser}}class se extends A{constructor(e,t){super(),this.segmentsQueue=[],this.acceptNewSegments=!1,this.playbackActive=!1,this.shouldFlushData=!1,this.bufferStartTime=0,this.bufferEndTime=0,this.addingSegments=!1,this.latencyReportTimeCycle=0,this.main=e,this.playbackController=t,this.logger=e.getLogger(),this.playerType=R.MSE,this.videoObject=e.getVideoContainer().getVideoObject(),this.mediaSource=new MediaSource,this.logger.info(this,"MSEPlayer :: Initializing MSE Player"),this.main.addEventListener("streamStateChange",e=>{N[e.state]==N.PUBLISHED&&this.stoppedByBrowser&&null!=this.videoObject&&(this.stoppedByBrowser=!1,this.playbackController.play())})}start(){null!=this.videoObject&&(this.acceptNewSegments=!0,this.mediaSource=new MediaSource,this.videoObject.src=URL.createObjectURL(this.mediaSource),this.mediaSource.addEventListener("sourceopen",()=>{this.onMediaSourceOpen()},!1),setInterval(()=>{this.timerEvent()},1e3),this.videoObject.onplay=()=>{this.onVideoPlay()},this.videoObject.onpause=e=>{this.onVideoPause()},this.videoObject.onstalled=()=>{this.logger.info(this,"VideoElement has stalled"),this.playbackController.setPlaybackState(N.BUFFERING)},this.videoObject.onerror=function(e){console.log("error",e)},this.videoObject.onwaiting=()=>{})}onMetaData(e){null!=this.videoObject&&(null!=this.mediaSource&&(null!=this.sourceBuffer&&(this.sourceBuffer.onupdateend=null,this.sourceBuffer=null),this.mediaSource=new MediaSource,this.videoObject.src=URL.createObjectURL(this.mediaSource),this.mediaSource.addEventListener("sourceopen",()=>{this.onMediaSourceOpen()},!1)),this.acceptNewSegments=!0,this.logger.info(this,"MetaData set"),this.playbackController.setPlaybackState(N.BUFFERING),this.metaData=e)}onMediaSourceOpen(){null!=this.mediaSource&&(this.mediaSource.duration=0),null==this.sourceBuffer&&(this.sourceBuffer=this.mediaSource.addSourceBuffer('video/mp4; codecs="avc1.42E01E, mp4a.40.2"'),this.sourceBuffer.mode="segments",this.bufferStartTime=(new Date).getTime(),this.addingSegments=!1,this.sourceBuffer.onupdateend=()=>{this.appendSourceBuffer()})}appendSourceBuffer(){null==this.sourceBuffer||this.sourceBuffer.updating||(this.shouldFlushData?this.flushVideoCache():0<this.segmentsQueue.length?(this.sourceBuffer.appendBuffer(this.segmentsQueue.shift()),this.checkVideoBuffer()):this.addingSegments=!1)}checkVideoBuffer(){var e,t;null!=this.videoObject&&(e=0<this.videoObject.buffered.length?this.videoObject.buffered.end(this.videoObject.buffered.length-1):0,this.playbackController.getPlaybackState()==N.BUFFERING&&e>this.main.getConfigManager().getSettings().getBufferConfig().getStartValue()&&(this.bufferEndTime=(new Date).getTime(),t=this.bufferEndTime-this.bufferStartTime,this.logger.success(this,`Buffer is full (completed in: ${t}ms )`),this.playbackController.setPlaybackState(N.UNKNOWN),this.main.dispatchEvent("bufferingComplete",{ref:this.main,mode:this.getPlayerType()}),this.videoObject.play().then(()=>{}).catch(e=>{this.logger.error(this,"Error on playback: "+e),this.playbackController.setPlaybackState(N.PAUSED),this.main.dispatchEvent("interactionRequired",{ref:this.main,mode:"mse"})})),this.playbackController.getPlaybackState()==N.PLAYING)&&e<this.main.getConfigManager().getSettings().getBufferConfig().getMinValue()&&(this.logger.info(this,"VideoElement is waiting for data"),this.playbackController.setPlaybackState(N.BUFFERING),this.videoObject.pause())}timerEvent(){var e;null!=this.videoObject&&30<this.videoObject.duration&&(this.shouldFlushData=!0),this.playbackController.getPlaybackState()==N.PLAYING&&(this.latencyReportTimeCycle++,5<this.latencyReportTimeCycle)&&(this.latencyReportTimeCycle=0,null!=(e=null==(e=this.playbackController)?void 0:e.getConnection()))&&e.reportLatency(this.getVideoBufferSize())}getVideoBufferSize(){return null!=this.videoObject&&0<this.videoObject.buffered.length?this.videoObject.buffered.end(this.videoObject.buffered.length-1)-this.videoObject.currentTime:0}pushData(e){this.acceptNewSegments&&(this.segmentsQueue.push(e),0==this.addingSegments)&&(this.addingSegments=!0,this.appendSourceBuffer())}play(){}pause(){var e;switch(this.logger.info(this,"Pause clicked | State: "+this.playbackController.getPlaybackState()),this.playbackController.getPlaybackState()){case N.UNKNOWN:case N.BUFFERING:case N.PAUSED:case N.PLAYING:this.acceptNewSegments=!1,null!=(e=this.videoObject)&&e.pause(),this.segmentsQueue=[];break;default:this.logger.info(this,"Pause clicked | Nothing to do")}}stop(){switch(null!=this.videoObject&&(this.videoObject.onpause=null,this.videoObject.onstalled=null,this.videoObject.onplay=null),this.playbackController.getPlaybackState()){case N.BUFFERING:case N.PLAYING:this.acceptNewSegments=!1,null!=this.sourceBuffer&&(this.sourceBuffer.onupdateend=null,this.sourceBuffer=null),this.mediaSource=new MediaSource,this.videoObject.src=URL.createObjectURL(this.mediaSource),this.videoObject.load(),this.segmentsQueue=[];break;default:this.logger.info(this,"Pause clicked | Nothing to do")}this.playbackController.setPlaybackState(N.STOPPED)}getAbsoluteTime(){return 0}getTime(){return 0}isPlaying(){return this.playbackActive}onVideoPause(){this.playbackController.getPlaybackState()==N.PLAYING&&(this.logger.info(this,"Playback paused!"),this.stoppedByBrowser=!0,this.playbackActive=!1,this.playbackController.setPlaybackState(N.PAUSED))}onVideoPlay(){this.stoppedByBrowser?(this.logger.warning(this,"Playback was previously stopped by the browser!"),this.stoppedByBrowser=!1,this.videoObject.pause(),this.playbackController.play()):(this.logger.info(this,"Playback started!"),this.playbackActive=!0,this.playbackController.setPlaybackState(N.PLAYING))}onVideoStop(){}restart(){}seek(e){return!1}setURL(e){}flushVideoCache(){var e;null==this.mediaSource||null==this.sourceBuffer||this.sourceBuffer.updating||(6<(e=this.videoObject.duration)&&this.sourceBuffer.remove(0,e-5),this.shouldFlushData=!1)}destroy(){var e;this.acceptNewSegments=!1,null!=(e=this.videoObject)&&e.pause(),null!=this.mediaSource&&(this.sourceBuffer=null),this.segmentsQueue=[],this.videoObject=null}}class oe extends A{constructor(e,t){super(),this.playbackActive=!1,this.main=e,this.playbackController=t,this.logger=e.getLogger(),this.playerType=R.HLS,this.videoObject=e.getVideoContainer().getVideoObject(),this.logger.info(this,"HLSPlayer :: Initializing HLS Player"),this.main.addEventListener("streamStateChange",e=>{N[e.state]==N.PUBLISHED&&this.stoppedByBrowser&&null!=this.videoObject&&(this.stoppedByBrowser=!1,this.playbackController.play())})}start(){null!=this.videoObject&&(setInterval(()=>{this.timerEvent()},1e3),this.videoObject.onplay=()=>{this.onVideoPlay()},this.videoObject.onpause=()=>{this.onVideoPause()},this.videoObject.onstalled=()=>{this.logger.info(this,"VideoElement has stalled")},this.videoObject.onerror=function(e){console.log("error",e)},this.videoObject.onwaiting=()=>{})}onMetaData(e){null!=this.videoObject&&(this.logger.info(this,"MetaData set"),this.metaData=e)}checkVideoBuffer(){var e;null!=this.videoObject&&(e=0<this.videoObject.buffered.length?this.videoObject.buffered.end(this.videoObject.buffered.length-1):0,this.playbackController.getPlaybackState()==N.BUFFERING&&e>this.main.getConfigManager().getSettings().getBufferConfig().getStartValue()&&(this.logger.success(this,"Buffer is full"),this.playbackController.setPlaybackState(N.UNKNOWN),this.videoObject.play().then(()=>{}).catch(e=>{this.logger.success(this,"Error on playback"+e)})),this.playbackController.getPlaybackState()==N.PLAYING)&&e<this.main.getConfigManager().getSettings().getBufferConfig().getMinValue()&&(this.logger.info(this,"VideoElement is waiting for data"),this.playbackController.setPlaybackState(N.BUFFERING),this.videoObject.pause())}timerEvent(){}getVideoBufferSize(){return null!=this.videoObject&&0<this.videoObject.buffered.length?this.videoObject.buffered.end(this.videoObject.buffered.length-1)-this.videoObject.currentTime:0}play(){}pause(){var e;switch(this.logger.info(this,"Pause clicked | State: "+this.playbackController.getPlaybackState()),this.playbackController.getPlaybackState()){case N.UNKNOWN:case N.BUFFERING:case N.PAUSED:case N.PLAYING:null!=(e=this.videoObject)&&e.pause();break;default:this.logger.info(this,"Pause clicked | Nothing to do")}}stop(){switch(this.playbackController.getPlaybackState()){case N.BUFFERING:case N.PLAYING:this.videoObject.load();break;default:this.logger.info(this,"Pause clicked | Nothing to do")}this.playbackController.setPlaybackState(N.STOPPED)}setURL(e){this.mediaURL=e,this.playbackController.setPlaybackState(N.BUFFERING),this.videoObject.src=this.mediaURL,null!=(e=this.videoObject)&&e.play()}getAbsoluteTime(){return 0}getTime(){return 0}isPlaying(){return this.playbackActive}onVideoPause(){this.playbackController.getPlaybackState()==N.PLAYING&&(this.logger.info(this,"Playback paused!"),this.playbackController.isTabHidden()&&(this.stoppedByBrowser=!0),this.playbackActive=!1,this.playbackController.setPlaybackState(N.PAUSED))}onVideoPlay(){this.stoppedByBrowser?(this.logger.warning(this,"Playback was previously stopped by the browser!"),this.stoppedByBrowser=!1,this.videoObject.pause(),this.playbackController.play()):(this.main.dispatchEvent("bufferingComplete",{ref:this.main,mode:this.getPlayerType()}),this.logger.info(this,"Playback started!"),this.playbackActive=!0,this.playbackController.setPlaybackState(N.PLAYING))}onVideoStop(){}restart(){}seek(e){return!1}destroy(){var e;null!=(e=this.videoObject)&&e.pause(),this.videoObject=null}}class re extends A{constructor(e,t){super(),this.segmentsQueue=[],this.acceptNewSegments=!1,this.playbackActive=!1,this.shouldFlushData=!1,this.bufferStartTime=0,this.bufferEndTime=0,this.addingSegments=!1,this.latencyReportTimeCycle=0,this.main=e,this.playbackController=t,this.logger=e.getLogger(),this.playerType=R.MSE,this.videoObject=e.getVideoContainer().getVideoObject(),this.mediaSource=new ManagedMediaSource,this.logger.info(this,"MMSPlayer :: Initializing MMS Player"),this.main.addEventListener("streamStateChange",e=>{N[e.state]==N.PUBLISHED&&this.stoppedByBrowser&&null!=this.videoObject&&this.playbackController.play()})}start(){null!=this.videoObject&&(this.acceptNewSegments=!0,this.mediaSource=new ManagedMediaSource,this.videoObject.disableRemotePlayback=!0,this.videoObject.controls=!1,this.videoObject.src=URL.createObjectURL(this.mediaSource),this.mediaSource.addEventListener("sourceopen",()=>{this.onMediaSourceOpen()},!1),setInterval(()=>{this.timerEvent()},1e3),this.videoObject.onplay=()=>{this.onVideoPlay()},this.videoObject.onpause=e=>{this.onVideoPause()},this.videoObject.onstalled=()=>{this.logger.info(this,"VideoElement has stalled"),this.playbackController.setPlaybackState(N.BUFFERING)},this.videoObject.onerror=function(e){console.log("error",e)},this.videoObject.onwaiting=()=>{})}onMetaData(e){null!=this.videoObject&&(null!=this.mediaSource&&(null!=this.sourceBuffer&&(this.sourceBuffer.onupdateend=null,this.sourceBuffer=null),this.mediaSource=new ManagedMediaSource,this.videoObject.disableRemotePlayback=!0,this.videoObject.controls=!1,this.videoObject.src=URL.createObjectURL(this.mediaSource),this.mediaSource.addEventListener("sourceopen",()=>{this.onMediaSourceOpen()},!1)),this.acceptNewSegments=!0,this.logger.info(this,"MetaData set"),this.playbackController.setPlaybackState(N.BUFFERING),this.metaData=e)}onMediaSourceOpen(){null!=this.mediaSource&&(this.mediaSource.duration=0),null==this.sourceBuffer&&(this.sourceBuffer=this.mediaSource.addSourceBuffer('video/mp4; codecs="avc1.42E01E, mp4a.40.2"'),null!=this.sourceBuffer)&&(this.sourceBuffer.mode="segments",this.bufferStartTime=(new Date).getTime(),this.addingSegments=!1,this.sourceBuffer.onupdateend=()=>{this.appendSourceBuffer()})}appendSourceBuffer(){null==this.sourceBuffer||this.sourceBuffer.updating||(this.shouldFlushData?this.flushVideoCache():0<this.segmentsQueue.length?(this.sourceBuffer.appendBuffer(this.segmentsQueue.shift()),this.checkVideoBuffer()):this.addingSegments=!1)}checkVideoBuffer(){var e,t;null!=this.videoObject&&(e=0<this.videoObject.buffered.length?this.videoObject.buffered.end(this.videoObject.buffered.length-1):0,this.playbackController.getPlaybackState()==N.BUFFERING&&e>this.main.getConfigManager().getSettings().getBufferConfig().getStartValue()&&(this.bufferEndTime=(new Date).getTime(),t=this.bufferEndTime-this.bufferStartTime,this.logger.success(this,`Buffer is full (completed in: ${t}ms )`),this.playbackController.setPlaybackState(N.UNKNOWN),this.main.dispatchEvent("bufferingComplete",{ref:this.main,mode:this.getPlayerType()}),this.videoObject.play().then(()=>{}).catch(e=>{this.logger.error(this,"Error on playback: "+e),this.playbackController.setPlaybackState(N.PAUSED),this.main.dispatchEvent("interactionRequired",{ref:this.main,mode:"mse"})})),this.playbackController.getPlaybackState()==N.PLAYING)&&e<this.main.getConfigManager().getSettings().getBufferConfig().getMinValue()&&(this.logger.info(this,"VideoElement is waiting for data"),this.playbackController.setPlaybackState(N.BUFFERING),this.videoObject.pause())}timerEvent(){var e;null!=this.videoObject&&30<this.videoObject.duration&&(this.shouldFlushData=!0),this.playbackController.getPlaybackState()==N.PLAYING&&(this.latencyReportTimeCycle++,5<this.latencyReportTimeCycle)&&(this.latencyReportTimeCycle=0,null!=(e=null==(e=this.playbackController)?void 0:e.getConnection()))&&e.reportLatency(this.getVideoBufferSize())}getVideoBufferSize(){return null!=this.videoObject&&0<this.videoObject.buffered.length?this.videoObject.buffered.end(this.videoObject.buffered.length-1)-this.videoObject.currentTime:0}pushData(e){this.acceptNewSegments&&(this.segmentsQueue.push(e),0==this.addingSegments)&&(this.addingSegments=!0,this.appendSourceBuffer())}play(){}pause(){var e;switch(this.logger.info(this,"Pause clicked | State: "+this.playbackController.getPlaybackState()),this.playbackController.getPlaybackState()){case N.UNKNOWN:case N.BUFFERING:case N.PAUSED:case N.PLAYING:this.acceptNewSegments=!1,null!=(e=this.videoObject)&&e.pause(),this.segmentsQueue=[];break;default:this.logger.info(this,"Pause clicked | Nothing to do")}}stop(){switch(null!=this.videoObject&&(this.videoObject.onpause=null,this.videoObject.onstalled=null,this.videoObject.onplay=null),this.playbackController.getPlaybackState()){case N.BUFFERING:case N.PLAYING:this.acceptNewSegments=!1,null!=this.sourceBuffer&&(this.sourceBuffer.onupdateend=null,this.sourceBuffer=null),this.mediaSource=new ManagedMediaSource,this.videoObject.src=URL.createObjectURL(this.mediaSource),this.videoObject.load(),this.segmentsQueue=[];break;default:this.logger.info(this,"Pause clicked | Nothing to do")}this.playbackController.setPlaybackState(N.STOPPED)}getAbsoluteTime(){return 0}getTime(){return 0}isPlaying(){return this.playbackActive}onVideoPause(){this.playbackController.getPlaybackState()==N.PLAYING&&(this.logger.info(this,"Playback paused!"),this.stoppedByBrowser=!0,this.playbackActive=!1,this.playbackController.setPlaybackState(N.PAUSED))}onVideoPlay(){this.stoppedByBrowser?(this.logger.warning(this,"Playback was previously stopped by the browser!"),this.stoppedByBrowser=!1,this.videoObject.pause(),this.playbackController.play()):(this.logger.info(this,"Playback started!"),this.playbackActive=!0,this.playbackController.setPlaybackState(N.PLAYING))}onVideoStop(){}restart(){}seek(e){return!1}setURL(e){}flushVideoCache(){var e;null==this.mediaSource||null==this.sourceBuffer||this.sourceBuffer.updating||(6<(e=this.videoObject.duration)&&this.sourceBuffer.remove(0,e-5),this.shouldFlushData=!1)}destroy(){var e;this.acceptNewSegments=!1,null!=(e=this.videoObject)&&e.pause(),null!=this.mediaSource&&(this.sourceBuffer=null),this.segmentsQueue=[],this.videoObject=null}}class ne{constructor(e){this.MSE_ENABLED=!0,this.HLS_ENABLED=!0,this.playbackState=N.NOT_INITIALIZED,this.previousPlaybackState=N.NOT_INITIALIZED,this.streamState=N.NOT_INITIALIZED,this.tabHidden=!1,this.wasPausedByUser=!1,this.wasFreezed=!1,this.wasPlayingBeforeFreeze=!1,this.lastSelectedBitrate=null,this.command="none",this.absoluteStreamTime=0,this.main=e,this.logger=e.getLogger(),this.connection=new V(this.main),this.connection.initialize(),this.command=this.main.getConfigManager().getSettings().getIfAutoStart()?"play":"pause",this.main.addEventListener("authorizationComplete",()=>{this.logger.info(this,"Library is ready for interaction!"),this.playbackState=N.INITIALIZED,this.main.getConfigManager().getConfigurationType()==l.EMBEDDED&&this.main.getConfigManager().getSettings().getIfAutoStart()&&this.start()}),this.main.addEventListener("streamStateChange",e=>{if(this.streamState=N[e.state],this.streamState==N.PUBLISHED)if("play"==this.command)switch(this.logger.info(this,"Stream is published, autostart!"),this.wasPlayingBeforeFreeze=!1,this.playbackState){case N.BUFFERING:case N.PLAYING:this.logger.info(this,"Switching video!"),this.pause(),this.start();break;case N.INITIALIZED:case N.STOPPED:this.logger.info(this,"Switching video!"),this.start();break;case N.PAUSED:this.logger.info(this,"Playback was paused, omitting...");break;default:this.logger.error(this,"Unsupported state on autostart: "+this.playbackState)}else this.logger.info(this,"Standby mode - no autostart "+this.command);this.streamState!=N.AWAITING&&this.streamState!=N.UNPUBLISHED&&this.streamState!=N.CLOSED||this.playbackState!=N.PAUSED&&this.playbackState!=N.PLAYING||this.setPlaybackState(N.STOPPED)}),document.addEventListener("visibilitychange",e=>{"visible"==document.visibilityState?M.isMobile()&&(this.logger.info(this,"Document is visible again, restoring player..."),this.tabHidden=!1,this.wasFreezed)&&(this.wasFreezed=!1,"play"==this.command)&&this.play():M.isMobile()&&(this.logger.info(this,"Document is not visible, stopping player..."),this.tabHidden=!0,this.wasFreezed=!0,this.stop())}),this.main.addEventListener("streamConfigChange",()=>{var e;this.logger.info(this,"Stream configuration has been updated - reloading..."),this.connection.disconnect(),this.connection.destroy(),null!=(e=this.player)&&e.destroy(),this.playbackState=N.STOPPED,this.connection=new V(this.main),this.connection.initialize()}),this.main.addEventListener("playbackProgress",e=>{this.absoluteStreamTime=e.streamStartTime+e.streamDuration})}start(){let e=!1;return this.connection.getConnectionState()==O.CONNECTED&&this.connection.getIfAuthorized()?(this.selectedSource=this.selectSource(),null!=this.selectedSource&&(this.player=this.selectPlayer(this.selectedSource),null!=this.player)?(this.player.start(),this.connection.attachPlayer(this.player),this.connection.requestPlayback(this.selectedSource),this.playbackState=N.INITIALIZED,this.wasPlayingBeforeFreeze=!0,e=!0):this.playbackState=N.STOPPED):(this.logger.error(this,"Connection with the server is not working or not authorized!"),this.playbackState=N.STOPPED),e}playCommand(){return this.command="play",this.play()}play(){let e=!1;if(this.wasPausedByUser=!1,this.wasPlayingBeforeFreeze=!0,this.main.isInitialized())if(this.main.getConfigManager().getRole()==i.PLAYER)switch(this.logger.info(this,"Play enforced, current playbackState: "+this.playbackState),this.playbackState){case N.INITIALIZED:this.start();break;case N.STOPPED:this.connection.reinitialize();break;case N.NOT_INITIALIZED:this.start(),e=!0;break;case N.BUFFERING:case N.PAUSED:this.connection.sendPlayRequest(),e=!0;break;case N.UNPUBLISHED:this.start(),e=!0;break;case N.UNKNOWN:this.restart(),e=!0;default:this.logger.warning(this," Play() clicked, but current playbackState is: "+this.playbackState)}else this.logger.error(this,"Could not play, since it's not working in player-mode!"),e=!1;else this.logger.error(this,"Library has not been initialized yet!"),e=!1;return e}pauseCommand(){return this.command="pause",this.pause()}pause(){var e;let t=!1;if(this.wasPlayingBeforeFreeze=!1,this.main.isInitialized())if(this.main.getConfigManager().getRole()==i.PLAYER)switch(this.wasPausedByUser=!0,this.playbackState){case N.BUFFERING:this.setPlaybackState(N.PAUSED),null!=(e=this.player)&&e.pause(),this.connection.sendPauseRequest();break;case N.UNKNOWN:case N.PLAYING:this.setPlaybackState(N.PAUSED),null!=(e=this.player)&&e.pause(),this.connection.sendPauseRequest();break;default:this.logger.warning(this," Pause() clicked, but current playbackState is: "+this.playbackState)}else this.logger.error(this,"Could not pause, since it's not working in player-mode!"),t=!1;else this.logger.error(this,"Library has not been initialized yet!"),t=!1;return t}togglePlay(){let e=!1;if(this.main.isInitialized())if(this.main.getConfigManager().getRole()==i.PLAYER)switch(this.playbackState){case N.UNKNOWN:case N.PLAYING:case N.BUFFERING:this.command="pause",this.pause();break;case N.INITIALIZED:case N.STOPPED:case N.NOT_INITIALIZED:case N.PAUSED:this.play(),this.command="play"}else this.logger.error(this,"Could not toggle, since it's not working in player-mode!"),e=!1;else this.logger.error(this,"Library has not been initialized yet!"),e=!1;return e}isPlaying(){return this.playbackState==N.PLAYING||this.playbackState==N.BUFFERING}stopCommand(){return this.command="pause",this.stop()}stop(){let e=!1;return this.main.isInitialized()?this.main.getConfigManager().getRole()==i.PLAYER?(this.connection.disconnect(),null!=this.player?this.player.stop():this.setPlaybackState(N.STOPPED)):(this.logger.error(this,"Could not play, since it's not working in player-mode!"),e=!1):(this.logger.error(this,"Library has not been initialized yet!"),e=!1),e}mute(){let e=!1;return this.main.isInitialized()?this.main.getConfigManager().getRole()==i.PLAYER?this.main.getVideoContainer().mute():(this.logger.error(this,"Could not pause, since it's not working in player-mode!"),e=!1):(this.logger.error(this,"Library has not been initialized yet!"),e=!1),e}unmute(){let e=!1;return this.main.isInitialized()?this.main.getConfigManager().getRole()==i.PLAYER?this.main.getVideoContainer().unmute():(this.logger.error(this,"Could not pause, since it's not working in player-mode!"),e=!1):(this.logger.error(this,"Library has not been initialized yet!"),e=!1),e}toggleMute(){let e=!1;return this.main.isInitialized()?this.main.getConfigManager().getRole()==i.PLAYER&&(this.main.getVideoContainer().getVideoObject().muted?this.unmute():this.mute(),e=!0):this.logger.error(this,"Library has not been initialized yet!"),e}setVolume(e){let t=!1;return this.main.isInitialized()?this.main.getConfigManager().getRole()==i.PLAYER&&(this.main.getVideoContainer().setVolume(e),t=!0):this.logger.error(this,"Library has not been initialized yet!"),t}getVolume(){let e=0;return this.main.isInitialized()?this.main.getConfigManager().getRole()==i.PLAYER&&(e=this.main.getVideoContainer().getVolume()):this.logger.error(this,"Library has not been initialized yet!"),e}selectPlayer(e){let t=null;if(this.main.getConfigManager().getRole()==i.PLAYER){switch(e.getType()){case n.WEBRTC:this.logger.error(this,"No WebRTC Player implementation!");break;case n.STORM:case n.RTMP:null==t&&M.hasMMSSupport()&&this.main.getConfigManager().getSettings().getIfProtocolEnabled(n.STORM)&&this.MSE_ENABLED&&(this.logger.info(this,"MMS Player was picked for this source!"),t=new re(this.main,this)),null==t&&M.hasMSESupport()&&this.main.getConfigManager().getSettings().getIfProtocolEnabled(n.STORM)&&this.MSE_ENABLED&&(this.logger.info(this,"MSE Player was picked for this source!"),t=new se(this.main,this)),null==t&&!M.hasMSESupport()&&this.main.getConfigManager().getSettings().getIfProtocolEnabled(n.STORM)&&this.HLS_ENABLED&&(this.logger.info(this,"HLS Player was picked for this source!"),t=new oe(this.main,this));break;default:this.logger.error(this,"This device does not support any available media protocol!"),this.main.dispatchEvent("compatibilityError",{ref:this.main,message:"This device does not support any available media protocol!"})}null==t&&this.main.dispatchEvent("compatibilityError",{ref:this.main,message:"This device does not support any available media protocol!"})}return t}isMute(){let e=!1;if(this.main.isInitialized()){if(this.main.getConfigManager().getRole()==i.PLAYER)return this.main.getVideoContainer().getVideoObject().muted}else this.logger.error(this,"Library has not been initialized yet!"),e=!1;return e}restart(){var e;let t=!1;return this.main.isInitialized()?this.main.getConfigManager().getRole()==i.PLAYER?(this.connection.disconnect(),null!=(e=this.player)&&e.stop(),this.setPlaybackState(N.NOT_INITIALIZED),this.connection.startConnection()):(this.logger.error(this,"Could not play, since it's not working in player-mode!"),t=!1):(this.logger.error(this,"Library has not been initialized yet!"),t=!1),t}reinitialize(){}selectSource(){var e,t=this.main.getConfigManager().getStream().getSourceList();if(0===t.length)return null;let i;return i=null===this.lastSelectedBitrate?M.isMobile()?(e=t.sort((e,t)=>e.getStreamInfo().getBitrate()-t.getStreamInfo().getBitrate()))[Math.floor(e.length/2)]:t.reduce((e,t)=>e.getStreamInfo().getBitrate()<t.getStreamInfo().getBitrate()?t:e):t.reduce((e,t)=>Math.abs(t.getStreamInfo().getBitrate()-this.lastSelectedBitrate)<Math.abs(e.getStreamInfo().getBitrate()-this.lastSelectedBitrate)?t:e,t[0]),this.lastSelectedBitrate=i.getStreamInfo().getBitrate(),i}getPlaybackState(){return this.playbackState}getStreamState(){return this.streamState}setPlaybackState(e){var t;switch(this.previousPlaybackState=this.playbackState,e){case N.PLAYING:this.main.dispatchEvent("playbackStart",{ref:this.main,mode:this.player.getPlayerType(),streamKey:this.connection.getSourceItem().getStreamKey()}),0==(null==(t=this.main.getVideoElement())?void 0:t.muted)&&this.main.dispatchEvent("videoUnmuted",{ref:this.main});break;case N.PAUSED:this.logger.info(this,"Playback Pause Event!"),this.main.dispatchEvent("playbackPause",{ref:this.main,mode:this.player.getPlayerType(),streamKey:this.connection.getSourceItem().getStreamKey()}),this.previousPlaybackState=N.PAUSED;break;case N.BUFFERING:this.logger.info(this,"Playback Buffering Event!"),this.main.dispatchEvent("bufferingStart",{ref:this.main,mode:this.player.getPlayerType()});break;case N.STOPPED:null!=this.player&&(this.logger.info(this,"Playback Stop Event!"),this.main.dispatchEvent("playbackStop",{ref:this.main,mode:this.player.getPlayerType(),streamKey:null!=(t=null==(t=null==(t=this.connection)?void 0:t.getSourceItem())?void 0:t.getStreamKey())?t:"Unknown"}))}this.playbackState=e}getIfPausedbyUser(){return this.wasPausedByUser}getConnection(){return this.connection}switchSource(t){let i=!1;this.setPlaybackState(N.STOPPED),this.connection.sendPauseRequest();var s=this.main.getConfigManager().getStream().getSourceList();for(let e=0;e<s.length;e++){var o=s[e];if(o.getStreamInfo().getLabel()==t){this.lastSelectedBitrate=o.getStreamInfo().getBitrate(),this.connection.requestPlayback(o),i=!0;break}}return i}getAbsoluteStreamTime(){if(this.main.isInitialized()){if(this.main.getConfigManager().getRole()==i.PLAYER)return this.absoluteStreamTime}else this.logger.error(this,"Library has not been initialized yet!");return 0}setCurrentSource(e){this.lastSelectedBitrate=null!=e.getStreamInfo()?e.getStreamInfo().getBitrate():0,this.selectedSource=e}setCommand(e){this.command=e}isTabHidden(){return this.tabHidden}destroy(){null!=this.connection&&this.connection.destroy(),null!=this.player&&this.player.destroy()}}class D extends class{constructor(){this.listeners={}}addEventListener(t,i){var e=!(2<arguments.length&&void 0!==arguments[2])||arguments[2];this.listeners[t]||(this.listeners[t]=[]);let s=!1;if(null!=this.listeners[t]&&0<this.listeners[t].length)for(let e=0;e<this.listeners[t].length;e++)if(this.listeners[t][e][1]==i){s=!0;break}return this.logger.success(this,"Registering a new event: "+t),!s&&(this.listeners[t].push([t,i,e]),!0)}removeEventListener(t,i){let s=!1;if(null!=this.listeners[t]&&0<this.listeners[t].length)for(let e=0;e<this.listeners[t].length;e++){var o=this.listeners[t][e];if(i){if(o[1]==i){if(1!=o[2])break;s=!0,this.listeners[t].splice(e,1);break}}else s=!0,1==o[2]&&this.listeners[t].splice(e,1)}return this.logger.success(this,"Removing listener: "+t),s}removeAllEventListeners(){for(var e in this.logger.success(this,"Removing all listeners!"),this.listeners){var t=this.listeners[e];if(0<t.length)for(let e=0;e<t.length;e++)1==t[e][2]&&t.splice(e,1)}}dispatchEvent(t,i){if(null!=this.listeners[t]&&0<this.listeners[t].length)for(let e=0;e<this.listeners[t].length;e++)this.listeners[t][e][1].call(this,i)}}{constructor(e){super(),this.LIBRARY_VERSION="4.1.2",this.COMPILE_DATE="4/18/2024, 1:06:55 PM",this.LIBRARY_BRANCH="Main",this.PLAYER_PROTOCOL_VERSION=1,this.initialized=!1,this.wasUnmuted=!1,this.libraryID=D.NEXT_LIBRARY_ID++,"undefined"!=typeof window&&window.document&&window.document.createElement&&null!=e&&this.setStreamConfig(e)}initialize(){const e=this;if(null==this.streamConfig)throw Error("Stream Config was not provided for this library! A properly configured object must be provided through the constructor or via the setConfig method before using the initialize() method.");(this.config.getSettings().getIfStartOnDOMReadyEnabled()||this.config.getSettings().getIfIOSOnDomStartFixEnabled()&&"iOS"==M.getOS())&&"complete"!==document.readyState?document.onreadystatechange=function(){"complete"===document.readyState&&e.initialize()}:(this.videoContainer=new J(this),this.playbackController=new ne(this),this.initialized=!0,this.addEventListener("videoUnmuted",()=>{this.wasUnmuted=!0}))}setStreamConfig(e){var t=JSON.parse(JSON.stringify(e));null==this.streamConfig?(this.streamConfig=e,this.config=new p(t),this.logger=new E(this.config.getSettings().getDebugConfig(),this),this.logger.info(this,"LibraryID: "+this.libraryID),this.logger.info(this,"Version: "+this.LIBRARY_VERSION+" | Compile Date: "+this.COMPILE_DATE+" | Branch: "+this.LIBRARY_BRANCH),this.logger.info(this,"UserCapabilities :: Browser: "+M.getBrowserName()+" "+M.getBrowserVersion()),this.logger.info(this,"UserCapabilities :: Operating System: "+M.getOS()+" "+M.getOSVersion()),this.logger.info(this,"UserCapabilities :: isMobile: "+M.isMobile()),this.logger.info(this,"UserCapabilities :: hasMSESupport: "+M.hasMSESupport()),this.logger.info(this,"UserCapabilities :: hasWebSocketSupport: "+M.hasWebSocketsSupport()),this.logger.info(this,"UserCapabilities :: hasWebRTCSupport: "+M.hasWebRTCSupport()),this.logger.info(this,"UserCapabilities :: isCookieEnabled: "+M.isCookieEnabled()),this.config.print(this.logger),this.clientUser=new F,this.storageManager=new $(this)):(this.logger.info(this,"StreamConfig has been overwritten, dispatching streamConfigChanged!"),this.streamConfig=e,this.config=new p(t),this.config.print(this.logger),this.dispatchEvent("streamConfigChange",{ref:this,newConfig:this.streamConfig}))}play(){return this.playbackController.playCommand()}pause(){return this.playbackController.pauseCommand()}stop(){return this.playbackController.stopCommand()}restart(){return this.playbackController.restart()}togglePlay(){return this.playbackController.togglePlay()}seek(e){return!1}isPlaying(){return this.playbackController.isPlaying()}getPlaybackState(){return this.playbackController.getPlaybackState()}getStreamState(){return this.playbackController.getStreamState()}mute(){return this.playbackController.mute()}unmute(){return this.playbackController.unmute()}isMute(){return this.playbackController.isMute()}toggleMute(){return this.playbackController.toggleMute()}setVolume(e){return this.playbackController.setVolume(e)}getVolume(){return this.playbackController.getVolume()}getPlaybackController(){return this.playbackController}getSourceList(){if(this.initialized)return this.config.getStream().getSourceList();throw new Error("StormLibrary has not been initialized yet")}removeAllSources(){if(!this.initialized)throw new Error("StormLibrary has not been initialized yet");this.config.getStream().clearSourceList()}getCurrentSourceItem(){if(this.initialized)return null!=this.playbackController.getConnection()?this.playbackController.getConnection().getSourceItem():null;throw new Error("StormLibrary has not been initialized yet")}addSourceItem(e,t){if(!this.initialized)throw new Error("StormLibrary has not been initialized yet");e=this.config.getStream().addSourceStream(e);t&&null!=e&&this.playSource(e)}playSource(e){if(!this.initialized)throw new Error("StormLibrary has not been initialized yet");if(null==this.getPlaybackController().getConnection())throw new Error("StormLibrary has not established a connection with a server");this.getPlaybackController().setCurrentSource(e),this.getPlaybackController().getConnection().requestPlayback(e)}subscribe(e,t){if(!this.initialized)throw new Error("StormLibrary has not been initialized yet");if(null==this.getPlaybackController().getConnection())throw new Error("StormLibrary has not established a connection with a server");this.getPlaybackController().pause(),t&&this.getPlaybackController().setCommand("play"),this.getPlaybackController().getConnection().newSubscription(e)}getAbsoluteStreamTime(){return this.playbackController.getAbsoluteStreamTime()}setSize(e,t){if(!this.initialized)throw new Error("StormLibrary has not been initialized yet");null!==this.videoContainer&&this.videoContainer.setSize(e,t)}setWidth(e){if(!this.initialized)throw new Error("StormLibrary has not been initialized yet");null!==this.videoContainer&&this.videoContainer.setWidth(e)}setHeight(e){if(!this.initialized)throw new Error("StormLibrary has not been initialized yet");null!==this.videoContainer&&this.videoContainer.setHeight(e)}getWidth(){return this.videoContainer.getWidth()}getHeight(){return this.videoContainer.getHeight()}setScalingMode(e){if(!this.initialized)throw new Error("StormLibrary has not been initialized yet");null!==this.videoContainer&&this.videoContainer.setScalingMode(e)}getScalingMode(){if(this.initialized)return null!==this.videoContainer?this.videoContainer.getScalingMode():"none";throw new Error("StormLibrary has not been initialized yet")}enterFullScreen(){null!=this.videoContainer&&this.videoContainer.enterFullScreen()}exitFullScreen(){null!=this.videoContainer&&this.videoContainer.exitFullScreen()}isFullScreenMode(){return this.videoContainer.isFullScreenMode()}getLibraryID(){return this.libraryID}getStreamConfig(){return this.streamConfig}getConfigManager(){return this.config}getLogger(){return this.logger}getSettingsAsJSON(){return JSON.stringify(this.streamConfig)}getSettings(){return this.streamConfig}getPlayerProtocolVersion(){return this.PLAYER_PROTOCOL_VERSION}isInitialized(){return this.initialized}isConnected(){return null!=this.playbackController&&null!=this.playbackController.getConnection()&&this.playbackController.getConnection().isConnectionActive()}isAuthorized(){return null!=this.playbackController&&null!=this.playbackController.getConnection()&&this.playbackController.getConnection().getIfAuthorized()}getRole(){return"player"}getVersion(){return this.LIBRARY_VERSION}getBranch(){return this.LIBRARY_BRANCH}getStorageManager(){return this.storageManager}getVideoElement(){var e;return null==(e=this.videoContainer)?void 0:e.getVideoObject()}getVideoContainer(){return this.videoContainer}getIfUnmuted(){return this.wasUnmuted}dispatchEvent(e,t){super.dispatchEvent(e,t)}destroy(){null!=this.playbackController&&this.playbackController.destroy(),null!=this.videoContainer&&this.videoContainer.destroy(),this.removeAllEventListeners()}}return D.NEXT_LIBRARY_ID=0,function(e){return new D(e)}}();